P               SEGMENT
                ASSUME CS:P,DS:P
                ORG 100H

.386

;_STR tartalmt kiirja a kpernyre
PRINT MACRO _STR
                PUSH    AX DX
                MOV     DX,OFFSET _STR
                MOV     AH,9
                INT     21H
                POP     DX AX
ENDM

;FJL MEGNYITSA
GET_FILE_HANDLE MACRO _FILENAME, _HANDLE
                MOV     AH,3DH
                MOV     DX,OFFSET _FILENAME
                MOV     AL,2
                INT     21H
                JC      @OPEN_ERROR
                MOV     WORD PTR [_HANDLE],AX
ENDM

;fjl bezrs
CLOSE_FILE MACRO _HANDLE
                MOV     AH,3EH
                MOV     BX,_HANDLE
                INT     21H
                JC      @CLOSE_ERROR
ENDM

;olvass fjbl
READ_FILE MACRO _HANDLE, _PUFFER, _DB
                MOV     AH,3FH
                MOV     BX,_HANDLE
                MOV     DX,OFFSET _PUFFER
                MOV     CX,_DB
                INT     21H
                JC      @READ_ERROR
ENDM

;VRAKOZS
KESIK MACRO _IDO
LOCAL @ELSO,@MASODIK
                PUSH    AX CX DX
                MOV     CX,_IDO
                MOV     DX,3DAH
@ELSO:
                IN      AL,DX
                TEST    AL,8
                JZ      @ELSO
@MASODIK:
                IN      AL,DX
                TEST    AL,1
                JZ      @MASODIK
                DEC     CX
                JNZ     @ELSO
                POP     DX CX AX
ENDM

START:
LOCALS
JUMPS
                MOV     AX,13H
                INT     10H
                MOV     AX,0A000H
                MOV     ES,AX

                GET_FILE_HANDLE PALETTE,HANDLE
                READ_FILE HANDLE, PAL, DB_PALETTE
                CLOSE_FILE HANDLE

PALETTA:
                MOV     DX,3C8H
                MOV     AL,0
                OUT     DX,AL
                INC     DX
                MOV     SI,OFFSET PAL
                MOV     CX,64*3
                REP     OUTSB

                GET_FILE_HANDLE KEP,HANDLE
                READ_FILE HANDLE, PICTURE, DB_KEP
                CLOSE_FILE HANDLE

KEP_ODA:
                MOV     SI,OFFSET PICTURE
                MOV     DI,[SOR]
                ADD     DI,[OSZL]
                MOV     CX,100
                KESIK 1
@@C2:
                PUSH    CX
                DEC     DI
                MOV     BYTE PTR ES:[DI],0
                INC     DI
                MOV     CX,160
@@C1:
                MOV     AL,[SI]
                MOV     ES:[DI],AL
                INC     DI
                INC     SI
                DEC     CX
                JNZ     @@C1
                ADD     DI,160
                POP     CX
                DEC     CX
                JNZ     @@C2
                INC     [OSZL]
                CMP     [OSZL],160
                JNZ     KEP_ODA

KEP_LE:
                MOV     SI,OFFSET PICTURE
                MOV     DI,[SOR]
                ADD     DI,[OSZL]
                DEC     DI
                SUB     DI,320
                MOV     AL,0
                MOV     CX,160
                REP     STOSB
                ADD     DI,160
                MOV     CX,100
                KESIK 1
@@C2:
                PUSH    CX
                MOV     CX,160
@@C1:
                MOV     AL,[SI]
                MOV     ES:[DI],AL
                INC     DI
                INC     SI
                DEC     CX
                JNZ     @@C1
                ADD     DI,160
                POP     CX
                DEC     CX
                JNZ     @@C2
                ADD     [SOR],320
                CMP     [SOR],320*101
                JNZ     KEP_LE

KEP_VISSZA:
                MOV     SI,OFFSET PICTURE
                MOV     DI,[SOR]
                ADD     DI,[OSZL]
                SUB     DI,320
                MOV     CX,100
                KESIK 1
@@C2:
                PUSH    CX
                MOV     CX,160
@@C1:
                MOV     AL,[SI]
                MOV     ES:[DI],AL
                INC     DI
                INC     SI
                DEC     CX
                JNZ     @@C1
                MOV     BYTE PTR ES:[DI],0
                ADD     DI,160
                POP     CX
                DEC     CX
                JNZ     @@C2
                DEC     [OSZL]
                JNZ     KEP_VISSZA

KEP_FEL:
                MOV     SI,OFFSET PICTURE
                MOV     DI,[SOR]
                ADD     DI,[OSZL]
                SUB     DI,320
                MOV     CX,100
                KESIK 1
@@C2:
                PUSH    CX
                MOV     CX,160
@@C1:
                MOV     AL,[SI]
                MOV     ES:[DI],AL
                INC     DI
                INC     SI
                DEC     CX
                JNZ     @@C1
                ADD     DI,160
                POP     CX
                DEC     CX
                JNZ     @@C2
                ADD     DI,320
                MOV     AL,0
                MOV     CX,162
                REP     STOSB
                SUB     [SOR],320
                JNC     KEP_FEL

                MOV     AH,1
                INT     16H
                MOV     [SOR],0
                MOV     [OSZL],0
                JZ      KEP_ODA

                MOV     AX,3
                INT     10H
                JMP     KILEPES

@CLOSE_ERROR:
                PRINT E_CLOSE
                JMP     KILEPES
@OPEN_ERROR:
                PRINT E_OPEN
                JMP     KILEPES
@READ_ERROR:
                PRINT E_READ
KILEPES:
                EXITCODE 0

COLOR           STRUC
R               DB 0
G               DB 0
B               DB 0
ENDS

PAL             COLOR 256 DUP(<>)
KEP             DB "ZH2.RAW",0
DB_KEP          DW 16000
PALETTE         DB "ZH2.PAL",0
DB_PALETTE      DW 192
PICTURE         DB 160*100 DUP(0)
SOR             DW 0
OSZL            DW 0
E_OPEN          DB "Nem tudom megnyitni a fjlt.",10,13,"$"
E_CLOSE         DB "Nem tudom lezrni a fjlt.",10,13,"$"
E_READ          DB "Nem tudok olvasni a fjlbl.",10,13,"$"
HANDLE          DW 0

ENDS            P
END             START