Comment /* Szinusz tblzat generlsa ltalnos hosszal, kr kirajzolsa */

SINLEN = 512                            ; A SINTAB hossza 512 lesz

Sorhossz = 320
.486
LOCALS
Code16 SEGMENT USE16
ASSUME CS:Code16, DS:Code16
                ORG 100H
START:
                MOV     AX,13H
                INT     10H
                MOV     AX,0A000H
                MOV     ES,AX

                MOV     CX,SINLEN       ; SINLEN hossz lesz a tblzatunk

                MOV     SI,OFFSET SINTAB
                FNINIT
                FLDPI

                FIDIV   COUNT           ; Step = PI/(SINLEN/2)

                FLDZ
@@1:
                FLD     ST
                FSIN
                FADD    PLUS1
                FMUL    AMPL
                FISTP   WORD PTR [SI]
                FADD    ST,ST(1)
                ADD     SI,2
                LOOP    @@1
                FSTP    TRASH
                FSTP    TRASH

                SUB     SI,SI           ; A SI mutat a szinusz rtkekre
                MOV     BX,SINLEN/2     ; A BX mutat a koszinusz rtkekre
                MOV     CX,SINLEN       ; A kirajzolt pontok szma
@@2:
                MOV     AX,Sorhossz     ; A kppont cmnek kiszmolsa:
                MUL     WORD PTR SINTAB[SI]
                ADD     AX,SINTAB[BX]   ; SINTAB[SI]*Sorhossz + COSTAB[BX]
                MOV     DI,AX           ; ES:[DI]-re egy fehr pont
                MOV     BYTE PTR ES:[DI],15
                ADD     SI,2            ; Szinusz mutatjt lptetjk
                AND     SI,2*SINLEN-2   ; Szinusz mutatjt normljuk
                ADD     BX,2            ; Koszinusz mutatjt lptetjk
                AND     BX,2*SINLEN-2   ; Koszinusz mutatjt normljuk
                LOOP    @@2             ; Kvetkez pont

                MOV     AH,0
                INT     16H
                MOV     AX,3
                INT     10H
                EXITCODE 0

COUNT           DD      SINLEN/2        ; Pi-ig SINLEN/2 szget trolunk le

PLUS1           DD      1.0
AMPL            DD      99.5
TRASH           DD      ?

SINTAB          DW      SINLEN DUP(?)   ; A tblzat helye (SINLEN db WORD)

Code16 ENDS
END START
