Comment /* Sprite mozgatsa krplyn az elz fzis trlsvel */

SINLEN = 128                            ; 128 rtk -> lasabb mozgs

Sorhossz = 320
.486
LOCALS
Code16 SEGMENT USE16
ASSUME CS:Code16, DS:Code16
                ORG 100H
START:
                MOV     AX,13H
                INT     10H
                MOV     AX,0A000H
                MOV     ES,AX
                FNINIT
                MOV     CX,SINLEN
                MOV     SI,OFFSET XSINTAB
                FLDPI
                FIDIV   COUNT
                FLDZ
@@0:
                FLD     ST
                FSIN
                FADD    PLUS1
                FMUL    RX
                FISTP   WORD PTR [SI]
                FADD    ST,ST(1)
                ADD     SI,2
                LOOP    @@0
                FSTP    TRASH
                FSTP    TRASH
                MOV     CX,SINLEN
                MOV     SI,OFFSET YSINTAB
                FLDPI
                FIDIV   COUNT
                FLDZ
@@1:
                FLD     ST
                FSIN
                FADD    PLUS1
                FMUL    RY
                FISTP   WORD PTR [SI]
                FADD    ST,ST(1)
                ADD     SI,2
                LOOP    @@1
                FSTP    TRASH
                FSTP    TRASH
                MOV     DX,3C8H
                MOV     AL,0
                OUT     DX,AL
                INC     DX
                MOV     SI,OFFSET GPAL
                MOV     CX,256*3
                REP     OUTSB
                MOV     CX,SINLEN
@@2:
                MOV     DX,3DAH
@@3:
                IN      AL,DX
                TEST    AL,8
                JNZ     @@3
@@4:
                IN      AL,DX
                TEST    AL,8
                JZ      @@4

                MOV     AL,0            ; A trlszn indexe
                MOV     CX,63           ; A sprite magassga 63 pixel
@@6:
                PUSH    CX              ; Ciklusvltoz elmentse a verembe
                PUSH    DI              ; Sor elejnek elmentse a verembe
                MOV     CX,62           ; A sprite szlessge 62 pixel
                REP     STOSB           ; Egy sor trlse
                POP     DI              ; Sor elejnek visszatltse a verembl
                ADD     DI,Sorhossz     ; Pozicionls a kvetkez sor elejre
                POP     CX              ; Ciklusvltoz visszatltse
                LOOP    @@6             ; Kvetkez sor

                ADD     BX,2
                AND     BX,2*SINLEN-2
                MOV     AX,Sorhossz
                MUL     WORD PTR YSINTAB[BX]
                MOV     SI,BX
                ADD     SI,SINLEN/2
                AND     SI,2*SINLEN-2
                ADD     AX,XSINTAB[SI]
                ADD     AX,45
                MOV     DI,AX

                PUSH    DI              ; Kezdpozici elmentse a verembe

                MOV     SI,OFFSET GRAW
                MOV     CX,63
@@5:
                PUSH    CX
                PUSH    DI
                MOV     CX,62
                REP     MOVSB
                POP     DI
                ADD     DI,Sorhossz
                POP     CX
                LOOP    @@5

                POP     DI              ; Kezdpozici visszatltse a verembl

                MOV     AH,1
                INT     16H
                JZ      @@2
                MOV     AH,0
                INT     16H
                MOV     AX,3
                INT     10H
                EXITCODE 0

GPAL:           INCLUDE GOLOPAL.INC
GRAW:           INCLUDE GOLORAW.INC
RX              DD      80.4
RY              DD      67.0
COUNT           DD      SINLEN/2
PLUS1           DD      1.0
TRASH           DD      ?
XSINTAB         DW      SINLEN DUP(?)
YSINTAB         DW      SINLEN DUP(?)

Code16 ENDS
END START
