;MOZG LISSAJOUS GRBK + PALETTA
Sorhossz=320
SINLEN=256
SINDB=255
Code16 SEGMENT
ASSUME CS:Code16
                ORG 100H
.486
KESIK MACRO _IDO
LOCAL ELSO,MASODIK,INDUL
                PUSH    AX CX DX DI
                MOV     CX,_IDO
INDUL:
                XOR     DI,DI
                MOV     DX,3DAh
ELSO:
                IN      AL,DX
                TEST    AL,8
                JZ      ELSO
MASODIK:
                IN      AL,DX
                TEST    AL,1
                JZ      MASODIK
                DEC     CX
                JNZ     INDUL
                POP     DI DX CX AX
ENDM

LOCALS

START:
                MOV     CX,SINLEN
                MOV     SI,OFFSET YSINTAB
                FINIT
                FLDPI
                FIDIV   CONST256
                FLDZ
@@C1:
                FLD     ST(0)
                FSIN
                FADD    PLUS1
                FMUL    RY
                FISTP   WORD PTR [SI]
                FADD    ST,ST(1)
                ADD     SI,2
                DEC     CX
                JNZ     @@C1
                FSTP    TEMP
                FSTP    TEMP

                MOV     CX,SINLEN
                MOV     SI,OFFSET YSINTAB
@@1:
                MOV     AX,SORHOSSZ
                MUL     WORD PTR [SI]
                MOV     [SI],AX
                ADD     SI,2
                DEC     CX
                JNZ     @@1

                MOV     CX,SINLEN
                MOV     SI,OFFSET XSINTAB
                FINIT
                FLDPI
                FIDIV   CONST256
                FLDZ
@@C3:
                FLD     ST(0)
                FSIN
                FADD    PLUS1
                FMUL    RX
                FISTP   WORD PTR [SI]
                FADD    ST,ST(1)
                ADD     SI,2
                DEC     CX
                JNZ     @@C3
                FSTP    TEMP
                FSTP    TEMP

                MOV     AX,13H
                INT     10H
                MOV     AX,0A000H
                MOV     ES,AX
                MOV     AX,0

@INDUL:
                KESIK 1
                MOV     CX,SINLEN
@@1:
                MOV     BX,YP1
                MOV     DI,YSINTAB[BX]
                MOV     BX,YP2
                ADD     DI,YSINTAB[BX]
                MOV     BX,YP3
                ADD     DI,YSINTAB[BX]
                MOV     BX,XP1
                ADD     DI,XSINTAB[BX]
                MOV     BX,XP2
                ADD     DI,XSINTAB[BX]
                MOV     BX,XP3
                ADD     DI,XSINTAB[BX]
                MOV     BYTE PTR ES:[DI],0

                MOV     AX,[DXP1]
                ADD     XP1,AX
                AND     XP1,2*SINLEN-1

                MOV     AX,[DXP2]
                ADD     XP2,AX
                AND     XP2,2*SINLEN-1

                MOV     AX,[DXP3]
                ADD     XP3,AX
                AND     XP3,2*SINLEN-1

                MOV     AX,[DYP1]
                ADD     YP1,AX
                AND     YP1,2*SINLEN-1

                MOV     AX,[DYP2]
                ADD     YP2,AX
                AND     YP2,2*SINLEN-1

                MOV     AX,[DYP3]
                ADD     YP3,AX
                AND     YP3,2*SINLEN-1
                DEC     CX
                JNZ     @@1

                ADD     XP1,2
                AND     XP1,2*SINLEN-1
                ADD     XP2,-2
                AND     XP2,2*SINLEN-1
                ADD     XP3,2
                AND     XP3,2*SINLEN-1

                ADD     YP1,-2
                AND     YP1,2*SINLEN-1
                ADD     YP2,2
                AND     YP2,2*SINLEN-1
                ADD     YP3,-2
                AND     YP3,2*SINLEN-1

                MOV     CX,SINLEN
@@2:
                MOV     BX,YP1
                MOV     DI,YSINTAB[BX]
                MOV     BX,YP2
                ADD     DI,YSINTAB[BX]
                MOV     BX,YP3
                ADD     DI,YSINTAB[BX]
                MOV     BX,XP1
                ADD     DI,XSINTAB[BX]
                MOV     BX,XP2
                ADD     DI,XSINTAB[BX]
                MOV     BX,XP3
                ADD     DI,XSINTAB[BX]
                MOV     BYTE PTR ES:[DI],CL

                MOV     AX,[DXP1]
                ADD     XP1,AX
                AND     XP1,2*SINLEN-1

                MOV     AX,[DXP2]
                ADD     XP2,AX
                AND     XP2,2*SINLEN-1

                MOV     AX,[DXP3]
                ADD     XP3,AX
                AND     XP3,2*SINLEN-1

                MOV     AX,[DYP1]
                ADD     YP1,AX
                AND     YP1,2*SINLEN-1

                MOV     AX,[DYP2]
                ADD     YP2,AX
                AND     YP2,2*SINLEN-1

                MOV     AX,[DYP3]
                ADD     YP3,AX
                AND     YP3,2*SINLEN-1
                DEC     CX
                JNZ     @@2

                ;PALETTA FUTTATS
                INC     BP
                CMP     BP,SINDB
                JC      @@CIKL
                SUB     BP,BP
@@CIKL:
                MOV     SI,OFFSET PAL
                MOV     DX,3C8H
                MOV     AX,BP
                INC     AX
                OUT     DX,AL
                INC     DX
                MOV     CX,SINDB*3
                SUB     CX,BP
                SUB     CX,BP
                SUB     CX,BP
                REP     OUTSB
                DEC     DX
                MOV     AL,1
                OUT     DX,AL
                INC     DX
                MOV     CX,BP
                ADD     CX,BP
                ADD     CX,BP
                REP     OUTSB



                INC     [DARAB]
                CMP     [DARAB],300
                JNZ     TOVABB
                ;RGI TRLSE
                MOV     CX,SINLEN
@@3:
                MOV     BX,YP1
                MOV     DI,YSINTAB[BX]
                MOV     BX,YP2
                ADD     DI,YSINTAB[BX]
                MOV     BX,YP3
                ADD     DI,YSINTAB[BX]
                MOV     BX,XP1
                ADD     DI,XSINTAB[BX]
                MOV     BX,XP2
                ADD     DI,XSINTAB[BX]
                MOV     BX,XP3
                ADD     DI,XSINTAB[BX]
                MOV     BYTE PTR ES:[DI],0

                MOV     AX,[DXP1]
                ADD     XP1,AX
                AND     XP1,2*SINLEN-1

                MOV     AX,[DXP2]
                ADD     XP2,AX
                AND     XP2,2*SINLEN-1

                MOV     AX,[DXP3]
                ADD     XP3,AX
                AND     XP3,2*SINLEN-1

                MOV     AX,[DYP1]
                ADD     YP1,AX
                AND     YP1,2*SINLEN-1

                MOV     AX,[DYP2]
                ADD     YP2,AX
                AND     YP2,2*SINLEN-1

                MOV     AX,[DYP3]
                ADD     YP3,AX
                AND     YP3,2*SINLEN-1
                DEC     CX
                JNZ     @@3
                ADD     [DXP1],0
                ADD     [DXP2],0
                ADD     [DXP3],0
                ADD     [DYP1],0
                ADD     [DYP2],0
                ADD     [DYP3],0
                AND     [DXP1],127
                AND     [DXP2],127
                AND     [DXP3],127
                AND     [DYP1],127
                AND     [DYP2],127
                AND     [DYP3],127
                MOV     [DARAB],0
TOVABB:
                MOV     AH,1
                INT     16H
                JZ      @INDUL

KILEPES:
                MOV     AH,0
                INT     16H
                MOV     AX,3
                INT     10H
                EXITCODE 0

XSINTAB         DW SINLEN DUP(?)
YSINTAB         DW SINLEN DUP(?)
CONST256        DD SINLEN/2
PLUS1           DD 1.0
RY              DD 33.0
RX              DD 53.0
TEMP            DD 0.0
DARAB           DW 0

XP1             DW 0
XP2             DW 0
XP3             DW 0
YP1             DW 0
YP2             DW 0
YP3             DW 0

;4,0,0,0,0,6
;0,0,4,6,0,8

DXP1            DW 0
DXP2            DW 0
DXP3            DW 4

DYP1            DW 6
DYP2            DW 0
DYP3            DW 8

_R = 0
_G = 0
_B = 0
PAL:
        REPT 63
                DB      _R,_G,_B
        _R = _R + 1
        ENDM
        REPT 63
                DB      _R,_G,_B
        _G = _G + 1
        _B = _B + 1
        ENDM
        REPT 63
                DB      _R,_G,_B
        _R = _R - 1
        _B = _B - 1
        ENDM
        REPT 63
                DB      _R,_G,_B
        _G = _G - 1
        ENDM
        DB      0,0,0
        DB      0,0,0

Code16 ENDS
END START
