;PLAZMA
SORHOSSZ=320
SINLEN=1024
SINDB=255
LOCALS
JUMPS
Code16 SEGMENT
ASSUME CS:Code16
.486
                ORG 100H
KESIK MACRO _IDO
LOCAL ELSO,MASODIK,INDUL
                PUSH    AX CX DX DI
                MOV     CX,_IDO
INDUL:
                XOR     DI,DI
                MOV     DX,3DAh
ELSO:
                IN      AL,DX
                TEST    AL,8
                JZ      ELSO
MASODIK:
                IN      AL,DX
                TEST    AL,1
                JZ      MASODIK
                DEC     CX
                JNZ     INDUL
                POP     DI DX CX AX
ENDM

START:
                MOV     AX,13H
                INT     10H
                MOV     AX,0A000H
                MOV     ES,AX

                MOV     CX,SINLEN
                MOV     SI,OFFSET XSINTAB
                FINIT
                FLDPI
                FIDIV   CONST128
                FLDZ
@@7:
                FLD     ST(0)
                FSIN
                FADD    PLUS1
                FMUL    RX
                FISTP   WORD PTR [SI]
                FADD    ST,ST(1)
                ADD     SI,2
                LOOP    @@7
                FSTP    TEMP
                FSTP    TEMP

                INC     BP
                CMP     BP,SINDB
                JC      @@CIKL1
                SUB     BP,BP
@@CIKL1:
                MOV     SI,OFFSET PAL
                MOV     DX,3C8H
                MOV     AX,BP
		ADD	AL,1
                OUT     DX,AL
                INC     DX
                MOV     CX,SINDB*3
                SUB     CX,BP
                SUB     CX,BP
                SUB     CX,BP
                REP     OUTSB
                DEC     DX
                MOV     AL,1
                OUT     DX,AL
                INC     DX
                MOV     CX,BP
                ADD     CX,BP
                ADD     CX,BP
                REP     OUTSB


                MOV     DI,0
                MOV     SI,0
                MOV     BP,0
                MOV     BX,0

                MOV     CX,200
CSOR:
                PUSH    CX SI BP BX
                MOV     CX,SORHOSSZ
                ;KESIK 1
C2:
                MOV     AX,XSINTAB[SI]
                ADD     AX,XSINTAB[BP]
                ADD     AX,XSINTAB[BX]
                INC     AX
                STOSB

                ADD     SI,2
                AND     SI,2*SINLEN-2
                ADD     BP,8
                AND     BP,2*SINLEN-2
                ADD     BX,2
                AND     BX,2*SINLEN-2

                DEC     CX
                JNZ     C2
                POP     BP BX SI CX

                ADD     SI,8
                AND     SI,2*SINLEN-2
                ADD     BP,2
                AND     BP,2*SINLEN-2
                ADD     BX,8
                AND     BX,2*SINLEN-2

                DEC     CX
                JNZ     CSOR

;                JMP     IDE

CNAGY:
                KESIK 1

                INC     BP
                CMP     BP,SINDB
                JC      @@CIKL
                SUB     BP,BP
@@CIKL:
                MOV     SI,OFFSET PAL
                MOV     DX,3C8H
                MOV     AX,BP
                INC     AX
                OUT     DX,AL
                INC     DX
                MOV     CX,SINDB*3
                SUB     CX,BP
                SUB     CX,BP
                SUB     CX,BP
                REP     OUTSB
                DEC     DX
                MOV     AL,1
                OUT     DX,AL
                INC     DX
                MOV     CX,BP
                ADD     CX,BP
                ADD     CX,BP
                REP     OUTSB

                MOV     AH,1
                INT     16H
                JZ      CNAGY
IDE:

                MOV     AH,0
                INT     16H
                MOV     AX,3
                INT     10H
                EXITCODE 0

CONST128        DD SINLEN/2
PLUS1           DD 1.0
RX              DD 21.0
TEMP            DD ?
XSINTAB         DW SINLEN DUP(?)
XP1             DW 0
XP2             DW 0
XP3             DW 0

_R=0
_G=0
_B=0
PAL:
        REPT 63
                DB      _R,_G,_B
        _R = _R - 1
        _G = _G - 1
        _B = _B + 1
        ENDM
        REPT 63
                DB      _R,_G,_B
        _R = _R + 1
        _G = _G + 1
        _B = _B - 1
        ENDM

        DB 0,0,0
        DB 0,0,0

Code16 ENDS
END START
