Comment /* Szinusz tblzat generlsa ltalnos hosszal, kr kirajzolsa */

SINLEN = 512                            ; A SINTAB hossz 512 lesz

Sorhossz = 320
.486
LOCALS
Code16 SEGMENT USE16
ASSUME CS:Code16
                ORG 100H
START:
                MOV     AX,13H
                INT     10H
                MOV     AX,0A000H
                MOV     ES,AX

                MOV     CX,SINLEN       ; SINLEN hossz lesz a tblzatunk

                MOV     SI,OFFSET SINTAB
                FNINIT
                FLDPI

                FIDIV   COUNT           ; Step = PI/(SINLEN/2)

                FLDZ
@@1:
                FLD     ST
                FSIN
                FADD    PLUS1
                FMUL    AMPL
                FISTP   WORD PTR [SI]
                FADD    ST,ST(1)
                ADD     SI,2
                LOOP    @@1
                FSTP    TRASH
                FSTP    TRASH

                mov     dx, 3c8H
                mov     al, 0
                out     dx, al
                inc     dx
                mov     cx, 63
c1:
                out     dx, al
                out     dx, al
                out     dx, al
                inc     al
                loop    c1
                out     dx, al
                out     dx, al
                out     dx, al
                mov     cx, 64
c2:
                out     dx, al
                out     dx, al
                out     dx, al
                dec     al
                loop    c2

                xor     BX,bx
                xor     dx, dx

cnagy:

c3:

                MOV     DX,3DAH         ; Vrakozs kpernyvltsra
c4:
                IN      AL,DX
                TEST    AL,8
                JNZ     c4
c5:
                IN      AL,DX
                TEST    AL,8
                JZ      c5

                SUB     SI,SI           ; A SI mutat a szinusz rtkekre
                MOV     CX, 200         ; A kirajzolt pontok szma
                xor     di, di
@@2:
                push    cx si
                mov     cx, 320
@@3:
                mov     ax, sintab[si]
                stosb
                add     si, bx
                and     si, 2*sinlen-2
                loop    @@3
                pop     si cx
                add     si, dx
                and     si, 2*sinlen-2
                loop    @@2

                sub     bx, 2
                add     dx, 2
                and     bx, 2*sinlen-2
                and     dx, 2*sinlen-2

                mov     ah, 1
                int     16H
                jz      cnagy

                MOV     AH,0
                INT     16H
                MOV     AX,3
                INT     10H
                EXITCODE 0

COUNT           DD      SINLEN/2        ; Pi-ig SINLEN/2 szget trolunk le

PLUS1           DD      1.0
AMPL            DD      63.4
TRASH           DD      ?

SINTAB          DW      SINLEN DUP(?)   ; A tblzat helye (SINLEN db WORD)


Code16 ENDS
END START
