Comment /* Szinusz tblzat generlsa ltalnos hosszal, kr kirajzolsa */

SINLEN = 512                            ; A SINTAB hossz 512 lesz

Sorhossz = 320
.486
LOCALS
Code16 SEGMENT USE16
ASSUME CS:Code16
                ORG 100H

include alap_ati.mac
START:
                MOV     AX,13H
                INT     10H
                MOV     AX,0A000H
                MOV     ES,AX

                MOV     CX,SINLEN       ; SINLEN hossz lesz a tblzatunk

                MOV     SI,OFFSET SINTAB
                FNINIT
                FLDPI

                FIDIV   COUNT           ; Step = PI/(SINLEN/2)

                FLDZ
@@1:
                FLD     ST
                FSIN
                FADD    PLUS1
                FMUL    AMPL
                FISTP   WORD PTR [SI]
                FADD    ST,ST(1)
                ADD     SI,2
                LOOP    @@1
                FSTP    TRASH
                FSTP    TRASH


                mov dx,3c8h
                mov al,0
                out dx,al
                inc dx
                mov cx,63
@@4:
                out dx,al
                out dx,al
                out dx,al
                inc ax
                loop @@4
                out dx,al
                out dx,al
                out dx,al
                mov cx,64
@@5:
                out dx,al
                out dx,al
                out dx,al
                dec ax
                loop @@5

                xor dx,dx
                xor bx,bx

billre:
                delay 1
                xor di,di
                sub si,si
                mov cx,200
@@2:
                push cx si
                mov cx,320
@@3:
                mov ax,sintab[si]
                stosb
                add si,bx
                and si,2*sinlen-2
                loop @@3
                pop si cx
                add si,dx
                and si,2*sinlen-2
                loop @@2

                sub bx,2
                add dx,2
                and bx,2*sinlen-2
                and dx,2*sinlen-2

                mov ah,1
                int 16h
                jz billre


                MOV     AH,0
                INT     16H
                MOV     AX,3
                INT     10H
                EXITCODE 0



COUNT           DD      SINLEN/2        ; Pi-ig SINLEN/2 szget trolunk le

PLUS1           DD      1.0
AMPL            DD      63.5
TRASH           DD      ?

SINTAB          DW      SINLEN DUP(?)   ; A tblzat helye (SINLEN db WORD)

Code16 ENDS
END START
