Comment /* Rajzunknak most az rtke vltozik szinuszosan s nem a pozicija,
           ld. p03b.asm */

SINLEN = 512
Sorhossz = 320
.486
LOCALS
Code16 SEGMENT USE16
ASSUME CS:Code16, DS:Code16
                ORG 100H
START:
                MOV     AX,13H
                INT     10H
                MOV     AX,0A000H
                MOV     ES,AX
                MOV     CX,SINLEN
                MOV     SI,OFFSET SINTAB
                FNINIT
                FLDPI
                FIDIV   COUNT
                FLDZ
@@1:
                FLD     ST
                FSIN
                FADD    PLUS1
                FMUL    AMPL
                FISTP   WORD PTR [SI]
                FADD    ST,ST(1)
                ADD     SI,2
                LOOP    @@1
                FSTP    TRASH
                FSTP    TRASH

                MOV     DX,3C8H         ; A sznek belltsa a 0. szntl
                MOV     AL,0
                OUT     DX,AL
                INC     DX
                MOV     CX,63           ; Az els 63 szn: feketbl fehrbe
@@2:
                OUT     DX,AL
                OUT     DX,AL
                OUT     DX,AL
                INC     AX
                LOOP    @@2
                OUT     DX,AL           ; A 64. szn: fehr
                OUT     DX,AL
                OUT     DX,AL
                MOV     CX,64           ; A kv. 64 szn: fehrbl feketbe
@@3:
                OUT     DX,AL
                OUT     DX,AL
                OUT     DX,AL
                DEC     AX
                LOOP    @@3

                SUB     SI,SI           ; A SI mutat a szinusz rtkekre (szg)
                SUB     DI,DI           ; A kperny elejn kezdjk a rajzolst
                MOV     CX,200          ; A kirajzolt sorok szma
@@4:
                PUSH    CX SI           ; Tbb regisztert is el lehet menteni
                MOV     CX,320          ; Soronknti kppontok szma
@@5:                
                MOV     AX,SINTAB[SI]   ; A kppont rtke: (SIN(szg)+1)*63.5
                STOSB
                ADD     SI,2
                AND     SI,2*SINLEN-2
                LOOP    @@5
                POP     SI CX           ; A szg ugyangy kezddik a kv.sorban
                LOOP    @@4

                MOV     AH,0
                INT     16H
                MOV     AX,3
                INT     10H
                EXITCODE 0

COUNT           DD      SINLEN/2
PLUS1           DD      1.0

AMPL            DD      63.5            ; Egy szn indexe max. 128 lehet

TRASH           DD      ?
SINTAB          DW      SINLEN DUP(?)

Code16 ENDS
END START
