Comment /* A kppontok rtkei vizszintes irnyban szinuszosan vltoznak,
           tbb szinuszos rtket sszeadva */

SINLEN = 256                            ; Cskknetjk a tblzat hosszt

Sorhossz = 320
.486
LOCALS
Code16 SEGMENT USE16
ASSUME CS:Code16, DS:Code16
                ORG 100H
START:
                MOV     AX,13H
                INT     10H
                MOV     AX,0A000H
                MOV     ES,AX
                MOV     CX,SINLEN
                MOV     SI,OFFSET SINTAB
                FNINIT
                FLDPI
                FIDIV   COUNT
                FLDZ
@@1:
                FLD     ST
                FSIN
                FADD    PLUS1
                FMUL    AMPL
                FISTP   WORD PTR [SI]
                FADD    ST,ST(1)
                ADD     SI,2
                LOOP    @@1
                FSTP    TRASH
                FSTP    TRASH
                MOV     DX,3C8H
                MOV     AL,0
                OUT     DX,AL
                INC     DX
                MOV     CX,63
@@2:
                OUT     DX,AL
                OUT     DX,AL
                OUT     DX,AL
                INC     AX
                LOOP    @@2
                OUT     DX,AL
                OUT     DX,AL
                OUT     DX,AL
                MOV     CX,64
@@3:
                OUT     DX,AL
                OUT     DX,AL
                OUT     DX,AL
                DEC     AX
                LOOP    @@3

                SUB     DI,DI
                MOV     CX,200
@@4:
                PUSH    CX

                PUSH    ALFA            ; Szgek mentse a verembe
                PUSH    BETA            ; (memria vltozt is lehet)
                PUSH    GAMMA

                MOV     CX,320
@@5:                
                MOV     SI,ALFA         ; A hrom szinuszrtk sszeadsa
                MOV     AX,SINTAB[SI]
                MOV     SI,BETA
                ADD     AX,SINTAB[SI]
                MOV     SI,GAMMA
                ADD     AX,SINTAB[SI]

                STOSB                   ; A kppont megjelentse

                ADD     ALFA,2          ; A szg1 lptetse vizszintes irnyban
                ADD     BETA,18         ; A szg2 lptetse vizszintes irnyban
                ADD     GAMMA,16        ; A szg3 lptetse vizszintes irnyban

                AND     ALFA,2*SINLEN-2 ; Szgek normlsa
                AND     BETA,2*SINLEN-2
                AND     GAMMA,2*SINLEN-2

                LOOP    @@5

                POP     GAMMA           ; Szgek visszatltse a verembl
                POP     BETA            ; (Minden sor azonos fzisban lesz)
                POP     ALFA

                POP     CX
                LOOP    @@4
                MOV     AH,0
                INT     16H
                MOV     AX,3
                INT     10H
                EXITCODE 0

ALFA            DW      0               ; A hrom szg kezdrtke: 0
BETA            DW      0
GAMMA           DW      0

COUNT           DD      SINLEN/2
PLUS1           DD      1.0

AMPL            DD      21.0            ; Hrom rtk addik ssze

TRASH           DD      ?
SINTAB          DW      SINLEN DUP(?)

Code16 ENDS
END START
