Comment /* PLASMA, paletta tmb definilsa nvekv kezdrtkekkel */

SZIN1ST = 1                             ; Az els hasznlt szn indexe
SZINDB = 128                            ; Hasznlt sznek szma

SINLEN = 256
Sorhossz = 320
.486
LOCALS
Code16 SEGMENT USE16
ASSUME CS:Code16, DS:Code16
                ORG 100H
START:
                MOV     AX,13H
                INT     10H
                MOV     AX,0A000H
                MOV     ES,AX
                MOV     CX,SINLEN
                MOV     SI,OFFSET SINTAB
                FNINIT
                FLDPI
                FIDIV   COUNT
                FLDZ
@@1:
                FLD     ST
                FSIN
                FADD    PLUS1
                FMUL    AMPL
                FISTP   WORD PTR [SI]
                FADD    ST,ST(1)        
                ADD     SI,2
                LOOP    @@1
                FSTP    TRASH
                FSTP    TRASH

                MOV     DX,3C8H         ; A paletta tmb kitltse a szn
                MOV     AL,SZIN1ST      ; regiszterekbe
                OUT     DX,AL
                INC     DX
                MOV     SI,OFFSET Pal
                MOV     CX,SZINDB*3
                REP     OUTSB

                SUB     DI,DI
                MOV     CX,200
@@2:
                PUSH    CX
                PUSH    ALFA
                PUSH    BETA
                PUSH    GAMMA
                MOV     CX,320
@@3:                
                MOV     SI,ALFA
                MOV     AX,SINTAB[SI]
                MOV     SI,BETA
                ADD     AX,SINTAB[SI]
                MOV     SI,GAMMA
                ADD     AX,SINTAB[SI]

                ADD     AX,SZIN1ST      ; A lehet legkisebb sznindex
                                        ; hozzadsa
                STOSB
                ADD     ALFA,2
                ADD     BETA,16
                ADD     GAMMA,18
                AND     ALFA,2*SINLEN-2
                AND     BETA,2*SINLEN-2
                AND     GAMMA,2*SINLEN-2
                LOOP    @@3
                POP     GAMMA
                POP     BETA
                POP     ALFA
                ADD     ALFA,6
                ADD     BETA,8
                ADD     GAMMA,10
                AND     ALFA,2*SINLEN-2
                AND     BETA,2*SINLEN-2
                AND     GAMMA,2*SINLEN-2
                POP     CX
                LOOP    @@2
                MOV     AH,0
                INT     16H
                MOV     AX,3
                INT     10H
                EXITCODE 0

Pal:
        _R = 63                                 ; A vrs komponenes: 63
        _G = 63                                 ; A zld komponenes elszr: 63
        _B = 0                                  ; A kk komponenes: 0
        REPT 63                                 ; 63 szn definilsa
                DB      _R,_G,_B
         _G = _G - 1                            ; A zld folyamatosan cskken
        ENDM
                DB      _R,_G,_B                ; Plus1 szn: a zld nulla
        REPT 63                                 ; Mg 63 szn definisa
                DB      _R,_G,_B
         _G = _G + 1                            ; A zld folyamatosan n
        ENDM
                DB      _R,_G,_B                ; Plus1 szn: a zld maximlis

ALFA            DW      0
BETA            DW      0
GAMMA           DW      0
COUNT           DD      SINLEN/2
PLUS1           DD      1.0
AMPL            DD      21.0
TRASH           DD      ?
SINTAB          DW      SINLEN DUP(?)

Code16 ENDS
END START
