Comment /* PLASMA, sznfuttats paletta tmbbl */

SZIN1ST = 1
SZINDB = 128
SINLEN = 256
Sorhossz = 320
.486
LOCALS
Code16 SEGMENT USE16
ASSUME CS:Code16, DS:Code16
                ORG 100H
START:
                MOV     AX,13H
                INT     10H
                MOV     AX,0A000H
                MOV     ES,AX
                MOV     CX,SINLEN
                MOV     SI,OFFSET SINTAB
                FNINIT
                FLDPI
                FIDIV   COUNT
                FLDZ
@@1:
                FLD     ST
                FSIN
                FADD    PLUS1
                FMUL    AMPL
                FISTP   WORD PTR [SI]
                FADD    ST,ST(1)        
                ADD     SI,2
                LOOP    @@1
                FSTP    TRASH
                FSTP    TRASH
                SUB     DI,DI
                MOV     CX,200
@@2:
                PUSH    CX
                PUSH    ALFA
                PUSH    BETA
                PUSH    GAMMA
                MOV     CX,320
@@3:                
                MOV     SI,ALFA
                MOV     AX,SINTAB[SI]
                MOV     SI,BETA
                ADD     AX,SINTAB[SI]
                MOV     SI,GAMMA
                ADD     AX,SINTAB[SI]
                ADD     AX,SZIN1ST
                STOSB
                ADD     ALFA,2
                ADD     BETA,16
                ADD     GAMMA,18
                AND     ALFA,2*SINLEN-2
                AND     BETA,2*SINLEN-2
                AND     GAMMA,2*SINLEN-2
                LOOP    @@3
                POP     GAMMA
                POP     BETA
                POP     ALFA
                ADD     ALFA,6
                ADD     BETA,8
                ADD     GAMMA,10
                AND     ALFA,2*SINLEN-2
                AND     BETA,2*SINLEN-2
                AND     GAMMA,2*SINLEN-2
                POP     CX
                LOOP    @@2

@@4:
                MOV     DX,3DAH         ; Vrakozs kpernyvltsra
@@5:
                IN      AL,DX
                TEST    AL,8
                JNZ     @@5
@@6:
                IN      AL,DX
                TEST    AL,8
                JZ      @@6
                                        ; SZNFUTTATS
                INC     BP              ; Fzis lptetse
                CMP     BP,SZINDB       ; Ha fzis = SZINDB,
                JC      @@7
                SUB     BP,BP           ; akkor fzis: 0
@@7:
                MOV     SI,OFFSET Pal   ; Sznek feltltse a Pal tmbbl
                MOV     DX,3C8H
                MOV     AX,BP           ; A fzis mutat az els sznre
                ADD     AL,SZIN1ST      ; Sznek feltltse folyamatosan
                OUT     DX,AL           ; a Pal tmb vgig
                INC     DX
                MOV     CX,SZINDB*3
                SUB     CX,BP
                SUB     CX,BP
                SUB     CX,BP
                REP     OUTSB
                DEC     DX              ; A maradk sznek feltltse fzisig
                MOV     AL,SZIN1ST
                OUT     DX,AL
                INC     DX
                MOV     CX,BP
                ADD     CX,BP
                ADD     CX,BP
                REP     OUTSB

                MOV     AH,1            ; Ha a billentyzet puffer res,
                INT     16H
                JZ      @@4             ; akkor jhet az jabb sznfeltlts

                MOV     AH,0
                INT     16H
                MOV     AX,3
                INT     10H
                EXITCODE 0

Pal:
        _R = 0                          ; Kk -> fehr, fehr -> kk paletta
        _G = 0
        _B = 63
        REPT 63
                DB      _R,_G,_B
         _R = _R + 1
         _G = _G + 1
        ENDM
                DB      _R,_G,_B
        REPT 63
                DB      _R,_G,_B
         _R = _R - 1
         _G = _G - 1
        ENDM
                DB      _R,_G,_B

ALFA            DW      0
BETA            DW      0
GAMMA           DW      0
COUNT           DD      SINLEN/2
PLUS1           DD      1.0
AMPL            DD      21.0
TRASH           DD      ?
SINTAB          DW      SINLEN DUP(?)

Code16 ENDS
END START
