SINLEN=512
SORHOSSZ=320
.486
LOCALS
Code16 SEGMENT USE16
ASSUME CS:Code16, DS:Code16
                ORG 100H

KESIK MACRO _IDO
LOCAL ELSO,MASODIK,INDUL
                PUSH    AX CX DX DI
                MOV     CX,_IDO
INDUL:
                XOR     DI,DI
                MOV     DX,3DAh
ELSO:
                IN      AL,DX
                TEST    AL,8
                JZ      ELSO
MASODIK:
                IN      AL,DX
                TEST    AL,1
                JZ      MASODIK
                DEC     CX
                JNZ     INDUL
                POP     DI DX CX AX
ENDM

START:
                MOV     AX,13H
                INT     10H
                MOV     AX,0A000H
                MOV     ES,AX

                MOV     CX,SINLEN+SINLEN/4
                MOV     SI,OFFSET SINTAB
;SZINUSZTBLA KSZTS
                FNINIT
                FLDPI
                FIDIV   COUNT
                FLDZ
@@1:
                FLD     ST
                FSIN
                FSTP    DWORD PTR [SI]
                FADD    ST,ST(1)
                ADD     SI,4
                LOOP    @@1
                FSTP    TRASH
                FSTP    TRASH

                MOV     CX,SINLEN
                MOV     SI,OFFSET [SINTAB]
CIKL:
                FLD     DWORD PTR [SI]
                FADD    PLUS1
                FMUL    AMPL
                FISTP   TRASH
                IMUL    DI,WORD PTR TRASH,SORHOSSZ
                ADD     DI,CX
                DEC     DI
                MOV     AL,15
                STOSB

                FLD     DWORD PTR [SI+sinlen]
                FADD    PLUS1
                FMUL    AMPL
                FISTP   TRASH
                IMUL    DI,WORD PTR TRASH,SORHOSSZ
                ADD     DI,CX
                DEC     DI
                ADD     SI,4
                MOV     AL,14
                STOSB

                DEC     CX
                JNZ     CIKL

                MOV     AH,0
                INT     16H







KEZDETELOTT:
                KESIK 1

                MOV     DI,0
                MOV     CX,SORHOSSZ*200/4
                MOV     EAX,0
                REP     STOSD

                MOV     SI,OFFSET [PONTOK]
                MOV     ECX,[SI]
                ADD     SI,4
@@KEZDET:
;PONTOK FORGATSA
                MOV     BX,ALFA
                FLD     [SI.X]  ;; X1
                FLD     sintab[BX]
                FLD     sintab[BX+SINLEN]
                FLD     [SI.Y]  ;; Y0  COS(a)  SIN(a)  X1
                FMUL    ST,ST(1);; Y0*COS(a)  COS(a)  SIN(a)  X1
                FLD     [SI.Z]  ;; Z0  Y0*COS(a)  COS(a)  SIN(a)  X1
                FMUL    ST,ST(3);; Z0*SIN(a)  Y0*COS(a)  COS(a)  SIN(a)  X1
                FSUBP   ST(1),ST;; Y1  COS(a)  SIN(a)  X1
                FXCH    ST(2)   ;; SIN(a)  COS(a)  Y1  X1
                FMUL    [SI.Y]  ;; Y0*SIN(a)  COS(a)  Y1  X1
                FXCH    ST(1)   ;; COS(a)  Y0*SIN(a)  Y1  X1
                FMUL    [SI.Z]  ;; Z0*COS(a)  Y0*SIN(a)  Y1  X1
                FADDP   ST(1),ST;; Z1  Y1  X1

                MOV     BX,BETA
                FLD     SINTAB[BX]
                FLD     SINTAB[BX+SINLEN]

                FLD     ST(4)   ;; X1  COS(_Y*Rad)  SIN(_Y*Rad)  Z1  Y1  X1
                FMUL    ST,ST(1);; X1*COS(_Y*Rad)  COS(_Y*Rad)  SIN(_Y*Rad)  Z1  Y1  X1
                FLD     ST(3)   ;; Z1  X1*COS(_Y*Rad)  COS(_Y*Rad)  SIN(_Y*Rad)  Z1  Y1  X1
                FMUL    ST,ST(3);; Z1*SIN(_Y*Rad)  X1*COS(_Y*Rad)  COS(_Y*Rad)  SIN(_Y*Rad)  Z1  Y1  X1
                FADD            ;; X2  COS(_Y*Rad)  SIN(_Y*Rad)  Z1  Y2  X1
                FXCH    ST(2)   ;; SIN(_Y*Rad)  COS(_Y*Rad)  X2  Z1  Y2  X1
                FMULP   ST(5),ST;; COS(_Y*Rad)  X2  Z1  Y2  X1*SIN(_Y*Rad)
                FMULP   ST(2),ST;; X2  Z1*COS(_Y*Rad)  Y2  X1*SIN(_Y*Rad)
                FXCH            ;; Z1*COS(_Y*Rad)  X2  Y2  X1*SIN(_Y*Rad)
                FSUBRP  ST(3),ST;; X2  Y2  Z2

                MOV     BX,GAMMA
                FLD     SINTAB[BX]
                FLD     SINTAB[BX+SINLEN]

                FLD     ST(2)   ;; X2  COS(_Z*Rad)  SIN(_Z*Rad)  X2  Y2  Z2
                FMUL    ST,ST(1);; X2*COS(_Z*Rad)  COS(_Z*Rad)  SIN(_Z*Rad)  X2  Y2  Z2
                FLD     ST(4)   ;; Y2  X2*COS(_Z*Rad)  COS(_Z*Rad)  SIN(_Z*Rad)  X2  Y2  Z2
                FMUL    ST,ST(3);; Y2*SIN(_Z*Rad)  X2*COS(_Z*Rad)  COS(_Z*Rad)  SIN(_Z*Rad)  X2  Y2  Z2
                FSUBP   ST(1),ST;; X3  COS(_Z*Rad)  SIN(_Z*Rad)  X2  Y2  Z2
                FXCH    ST(3)   ;; X2  COS(_Z*Rad)  SIN(_Z*Rad)  X3  Y2  Z2
                FMULP   ST(2),ST;; COS(_Z*Rad)  X2*SIN(_Z*Rad)  X3  Y2  Z2
                FMULP   ST(3),ST;; X2*SIN(_Z*Rad)  X3  Y2*COS(_Z*Rad)  Z2
                FADDP   ST(2),ST;; X3  Y3  Z3

                FLD     ELTOL
                FSUBP   ST(3),ST

;LEKPEZS A KPERNYRE
                FMUL    DIST
                FLD     DIST
                FSUB    ST,ST(3)
                FDIVP   ST(1),ST
                FISTP   WORD PTR [XX]

                FMUL    DIST
                FLD     DIST
                FSUB    ST,ST(2)
                FDIVP   ST(1),ST
                FISTP   WORD PTR [YY]

                FISTP   WORD PTR [ZZ]

                ADD     [XX],SORHOSSZ/2
                ADD     [YY],100

;KIRAJZOLS A KPERNYRE
                IMUL    DI,YY,SORHOSSZ
                ADD     DI,XX
                MOV     Ax,di
                and     ax,31
                add     ax,32
                STOSB

                ADD     SI,4*3
                DEC     ECX
                JNZ     @@KEZDET

                ADD     ALFA,8
                ADD     BETA,12
                ADD     GAMMA,20
                AND     ALFA,4*SINLEN-4
                AND     BETA,4*SINLEN-4
                AND     GAMMA,4*SINLEN-4

                MOV     AH,1
                INT     16H
                JZ      KEZDETELOTT

;KILPS
                MOV     AH,0
                INT     16H
                MOV     AX,3
                INT     10H
                EXITCODE 0

VECTOR STRUC
X      DD ?
Y      DD ?
Z      DD ?
ENDS

ALFA            DW      0
BETA            DW      0
GAMMA           DW      0

AMPL            DD      45.0
PLUS1           DD      1.0

ELTOL           DD      -250.0 ;500.0
DIST            DD      256.0 ;225.0

XX              DW      ?
YY              DW      ?
ZZ              DW      ?

COUNT           DD      SINLEN/2
TRASH           DD      ?
SINTAB          DD      SINLEN+SINLEN/4 DUP(?)


PONTOK LABEL DWORD
INCLUDE antenna.INC

Code16 ENDS
END START
