Comment /* Pontokbl ll trbeli objektum elforgatsa, eltolsa, majd
           lekpzse a skra (a kpernyre). */

SINLEN = 1024
Sorhossz = 320
Sorok = 200
.486
LOCALS
Code16 SEGMENT USE16
ASSUME CS:Code16, DS:Code16
                ORG 100H
START:
                MOV     AX,13H
                INT     10H
                MOV     AX,0A000H
                MOV     ES,AX

                CALL    SZINEK

                MOV     CX,SINLEN+SINLEN/4      ;Szinusz tblzat generlsa
                MOV     SI,OFFSET SINTAB        ;   -1.0 s +1.0 kz es
                FNINIT                          ;  lebegpontos rtkekkel
                FLDPI
                FIDIV   COUNT
                FLDZ
@@1:
                FLD     ST
                FSIN
                FSTP    DWORD PTR [SI]
                FADD    ST,ST(1)
                ADD     SI,4
                LOOP    @@1
                FSTP    TRASH
                FSTP    TRASH
@@2:
                MOV     CX,200
@@3:
                MOV     BP,OFFSET PONTOK
                PUSH    CX
                CALL    FORGATAS
                POP     CX
                FLD1
                FSUBR   PIVOT.X
                FSTP    PIVOT.X
                FLD1
                FADD    PIVOT.Y
                FSTP    PIVOT.Y
                LOOP    @@3                     ; kirajzolsa kvetkezik.

                JMP     @@2

FORGATAS:
@@2:
                MOV     BX,FAZISX
                FLD     SINTAB[BX]
                FMUL    SUGARX
                FSTP    PIVOT.X
                MOV     BX,FAZISY
                FLD     SINTAB[BX]
                FMUL    SUGARY
                FSTP    PIVOT.Y

                MOV     DX,3DAh         ; Vrakozs a kperny rajzolsra
@@3:
                IN      AL,DX
                TEST    AL,8
                JZ      @@3
@@4:
                IN      AL,DX
                TEST    AL,1
                JZ      @@4

                CALL    HATTER
                                        ; Pontok kirajzolsa
                MOV     SI,BP           ; Objektum cme
                MOV     ECX,[SI]        ; Objektum pontjainak a szma
                ADD     SI,4
@@5:                                    ; Egy pont kirajzolsa
                FLD     [SI.X]  ;; X1   ; Forgats

                MOV     BX,ALFA         ; X tengely krl ALFA-val
                FLD     SINTAB[BX]
                FLD     SINTAB[BX+SINLEN]

                FLD     [SI.Y]  ;; Y0  COS(a)  SIN(a)  X1
                FMUL    ST,ST(1);; Y0*COS(a)  COS(a)  SIN(a)  X1
                FLD     [SI.Z]  ;; Z0  Y0*COS(a)  COS(a)  SIN(a)  X1
                FMUL    ST,ST(3);; Z0*SIN(a)  Y0*COS(a)  COS(a)  SIN(a)  X1
                FSUBP   ST(1),ST;; Y1  COS(a)  SIN(a)  X1
                FXCH    ST(2)   ;; SIN(a)  COS(a)  Y1  X1
                FMUL    [SI.Y]  ;; Y0*SIN(a)  COS(a)  Y1  X1
                FXCH    ST(1)   ;; COS(a)  Y0*SIN(a)  Y1  X1
                FMUL    [SI.Z]  ;; Z0*COS(a)  Y0*SIN(a)  Y1  X1
                FADDP   ST(1),ST;; Z1  Y1  X1

                MOV     BX,BETA         ; Y tengely krl BETA-val
                FLD     SINTAB[BX]
                FLD     SINTAB[BX+SINLEN]

                FLD     ST(4)   ;; X1  COS(_Y*Rad)  SIN(_Y*Rad)  Z1  Y1  X1
                FMUL    ST,ST(1);; X1*COS(_Y*Rad)  COS(_Y*Rad)  SIN(_Y*Rad)  Z1  Y1  X1
                FLD     ST(3)   ;; Z1  X1*COS(_Y*Rad)  COS(_Y*Rad)  SIN(_Y*Rad)  Z1  Y1  X1
                FMUL    ST,ST(3);; Z1*SIN(_Y*Rad)  X1*COS(_Y*Rad)  COS(_Y*Rad)  SIN(_Y*Rad)  Z1  Y1  X1
                FADD            ;; X2  COS(_Y*Rad)  SIN(_Y*Rad)  Z1  Y2  X1
                FXCH    ST(2)   ;; SIN(_Y*Rad)  COS(_Y*Rad)  X2  Z1  Y2  X1
                FMULP   ST(5),ST;; COS(_Y*Rad)  X2  Z1  Y2  X1*SIN(_Y*Rad)
                FMULP   ST(2),ST;; X2  Z1*COS(_Y*Rad)  Y2  X1*SIN(_Y*Rad)
                FXCH            ;; Z1*COS(_Y*Rad)  X2  Y2  X1*SIN(_Y*Rad)
                FSUBRP  ST(3),ST;; X2  Y2  Z2

                MOV     BX,GAMMA        ; Z tengely krl GAMMA-val
                FLD     SINTAB[BX]
                FLD     SINTAB[BX+SINLEN]

                FLD     ST(2)   ;; X2  COS(_Z*Rad)  SIN(_Z*Rad)  X2  Y2  Z2
                FMUL    ST,ST(1);; X2*COS(_Z*Rad)  COS(_Z*Rad)  SIN(_Z*Rad)  X2  Y2  Z2
                FLD     ST(4)   ;; Y2  X2*COS(_Z*Rad)  COS(_Z*Rad)  SIN(_Z*Rad)  X2  Y2  Z2
                FMUL    ST,ST(3);; Y2*SIN(_Z*Rad)  X2*COS(_Z*Rad)  COS(_Z*Rad)  SIN(_Z*Rad)  X2  Y2  Z2
                FSUBP   ST(1),ST;; X3  COS(_Z*Rad)  SIN(_Z*Rad)  X2  Y2  Z2
                FXCH    ST(3)   ;; X2  COS(_Z*Rad)  SIN(_Z*Rad)  X3  Y2  Z2
                FMULP   ST(2),ST;; COS(_Z*Rad)  X2*SIN(_Z*Rad)  X3  Y2  Z2
                FMULP   ST(3),ST;; X2*SIN(_Z*Rad)  X3  Y2*COS(_Z*Rad)  Z2
                FADDP   ST(2),ST;; X3  Y3  Z3

                FLD     PIVOT.Z ;; PZ  X3  Y3  Z3       ;Eltols
                FADDP   ST(3),ST;; X3  Y3  Z4
                FLD     PIVOT.Y ;; PY  X3  Y3  Z4
                FADDP   ST(2),ST;; X3  Y4  Z4
                FADD    PIVOT.X ;; X4  Y4  Z4

                FMUL    DIST    ;; DIST*X4  Y4  Z4      ;Perspektvikus vetts
                FLD     DIST    ;; DIST  DIST*X4  Y4  Z4
                FSUB    ST,ST(3);; DIST-Z4  DIST*X4  Y4  Z4
                FDIVP   ST(1),ST;; XX  Y4  Z4
                FISTP   XX      ;; Y4  Z4

                FMUL    DIST    ;; DIST*Y4  Z4
                FLD     DIST    ;; DIST  DIST*Y4  Z4
                FSUB    ST,ST(2);; DIST-Z4  DIST*Y4  Z4
                FDIVP   ST(1),ST;; YY  Z4
                FISTP   YY      ;; ZZ   

                FADD    Const150
                FDIV    Const100
                FMUL    Const063

                FISTP   ZZ      ;; -

                ADD     XX,Sorhossz/2           ; Kzpre igazts
                ADD     YY,Sorok/2

                CMP     YY,Sorok                ; Vgs
                JNB     @@6
                CMP     XX,Sorhossz
                JNB     @@6

                IMUL    DI,YY,Sorhossz          ; Kirajzols a kpernyre
                ADD     DI,XX
                MOV     AL,BYTE PTR ZZ
                STOSB
@@6:
                ADD     SI,SIZE Vector          ; Lps a kvetkez pontra
                DEC     ECX
                JNZ     @@5

                CALL    SZIVAR

                ADD     ALFA,8                  ; j ALFA
                ADD     BETA,12                 ; j BETA
                ADD     GAMMA,20                ; j GAMMA
                AND     ALFA,4*SINLEN-4
                AND     BETA,4*SINLEN-4
                AND     GAMMA,4*SINLEN-4

                ADD     FAZISX,8
                ADD     FAZISY,16
                AND     FAZISX,4*SINLEN-4
                AND     FAZISY,4*SINLEN-4

                MOV     AH,1                    ; Ha nem trtnt billenty
                INT     16H                     ; nyoms, akkor jabb fzis
                JNZ     KILEP

                RETN

KILEP:
                MOV     AH,0                    ; Kilps a programbl
                INT     16H

                CALL    SOTETIT

                MOV     AX,3
                INT     10H
                EXITCODE 0
;------------------------------------------------------------------------------
SZINEK:

                MOV     DX,3C8H         ; Sznek belltsa
                MOV     AL,1
                OUT     DX,AL
                INC     DX

                MOV     CX,63           ; Szrke skla
@@1:
                OUT     DX,AL
                OUT     DX,AL
                OUT     DX,AL
                INC     AX
                LOOP    @@1

                MOV     AL,63           ; Piros szn belltsa
                OUT     DX,AL
                MOV     AL,0
                OUT     DX,AL
                OUT     DX,AL

                MOV     AL,63           ; Srga szn belltsa
                OUT     DX,AL
                OUT     DX,AL
                MOV     AL,0
                OUT     DX,AL

                MOV     AL,0            ; Zld szn belltsa
                OUT     DX,AL
                MOV     AL,63
                OUT     DX,AL
                MOV     AL,0
                OUT     DX,AL

                MOV     AL,0            ; Cyan szn belltsa
                OUT     DX,AL
                MOV     AL,63
                OUT     DX,AL
                OUT     DX,AL
                RETN
;------------------------------------------------------------------------------
HATTER:
                SUB     DI,DI
                MOV     CX,200*Sorhossz/2
                SUB     AX,AX
                REP     STOSW
                RETN
;------------------------------------------------------------------------------
SZIVAR:
                MOV     SZIN,67
                MOV     CX,319
                MOV     BP,195
                MOV     SI,315
                MOV     DI,199
                CALL    LINE
                MOV     CX,319
                MOV     BP,194
                MOV     SI,314
                MOV     DI,199
                CALL    LINE
                MOV     CX,319
                MOV     BP,193
                MOV     SI,313
                MOV     DI,199
                CALL    LINE
                MOV     SZIN,66
                MOV     CX,319
                MOV     BP,192
                MOV     SI,312
                MOV     DI,199
                CALL    LINE
                MOV     CX,319
                MOV     BP,191
                MOV     SI,311
                MOV     DI,199
                CALL    LINE
                MOV     CX,319
                MOV     BP,190
                MOV     SI,310
                MOV     DI,199
                CALL    LINE
                MOV     SZIN,65
                MOV     CX,319
                MOV     BP,189
                MOV     SI,309
                MOV     DI,199
                CALL    LINE
                MOV     CX,319
                MOV     BP,188
                MOV     SI,308
                MOV     DI,199
                CALL    LINE
                MOV     CX,319
                MOV     BP,187
                MOV     SI,307
                MOV     DI,199
                CALL    LINE
                MOV     SZIN,64
                MOV     CX,319
                MOV     BP,186
                MOV     SI,306
                MOV     DI,199
                CALL    LINE
                MOV     CX,319
                MOV     BP,185
                MOV     SI,305
                MOV     DI,199
                CALL    LINE
                MOV     CX,319
                MOV     BP,184
                MOV     SI,304
                MOV     DI,199
                CALL    LINE
                RETN
;------------------------------------------------------------------------------
SOTETIT:
                MOV     SI,OFFSET PAL; Sznek eltrolsa
                MOV     DX,3C7H
                MOV     AL,0
                OUT     DX,AL
                ADD     DX,2
                MOV     CX,768
@@3:
                IN      AL,DX
                MOV     [SI],AL
                INC     SI
                LOOP    @@3

                MOV     BX,1            ; Levonand = 0, irny = +1
@@4:
                MOV     DI,63
@@4B:
                MOV     DX,3DAH
@@5:
                IN      AL,DX
                TEST    AL,8
                JNZ     @@5
@@6:
                IN      AL,DX
                TEST    AL,8
                JZ      @@6

                MOV     SI,OFFSET PAL; Aktulis paletta belltsa
                MOV     DX,3C8H
                MOV     AL,0
                OUT     DX,AL
                INC     DX
                MOV     CX,768
@@7:
                LODSB
                ADD     AL,BH           ; A konponens rtkbl levonunk
                CMP     AL,63
                JC      @@8
                MOV     AL,63           ; Negatv rtk helyett 0
@@8:
                OUT     DX,AL
                LOOP    @@7             ; Kvetkez komponens
                ADD     BH,BL           ; Levonand lptetse
                DEC     DI
                JNZ     @@4B

VILI:
                MOV     BX,1            ; Levonand = 0, irny = +1
@@4:
                MOV     DI,62
@@4B:
                MOV     DX,3DAH
@@5:
                IN      AL,DX
                TEST    AL,8
                JNZ     @@5
@@6:
                IN      AL,DX
                TEST    AL,8
                JZ      @@6

                MOV     DX,3C8H
                MOV     AL,0
                OUT     DX,AL
                INC     DX
                MOV     AX,DI
                MOV     CX,768
@@7:
                OUT     DX,AL
                LOOP    @@7             ; Kvetkez komponens
                DEC     DI
                DEC     DI
                JNZ     @@4B

                RETN

;------------------------------------------------------------------------------
;DRAWING LINE 12-24-94 BY TOMCAT/ABADDON
;Based on Bresenham algorithm
;Publised by Paul S. Heckbert in Graphics Gems
;Translated to Assembly by Tamas Kaproncai tomcat@szif.hu

DrawLine        MACRO   _Plot,_Color
        LOCAL   _X2,_Y2,_1,_2,_3,_4,_5,_6,_7,_8

                MOV     _X2,SI
                MOV     _Y2,DI
                SUB     SI,CX           ;DX = X2 - X1
                SUB     DI,BP           ;DY = Y2 - Y1
                MOV     DX,SI
                MOV     BX,DI
                SHL     SI,1            ;AX = ABS(DX) * 2
                JNC     _1
                NEG     SI
_1:
                SHL     DI,1            ;AY = ABS(DY) * 2
                JNC     _2
                NEG     DI
_2:
                SAR     DX,16           ;SX = SGN(DX)
                SBB     DX,-1
                SAR     BX,16           ;SY = SGN(DY)
                SBB     BX,-1
                CMP     SI,DI
                JNA     _5              ;IF AX > AY
                MOV     AX,SI           ;  D = AY - AX / 2
                SHR     AX,1
                NEG     AX
                ADD     AX,DI
_3:                                     ;  DO
                _Plot CX,BP,_Color      ;    PLOT(X,Y)
                CMP     CX,_X2
                JE      _8              ;  UNTIL X = X2
                OR      AX,AX
                JS      _4              ;    IF D >= 0
                ADD     BP,BX           ;      Y += SY
                SUB     AX,SI           ;      D -= AX
_4:                                     ;    ENDIF
                ADD     CX,DX           ;    X += SX
                ADD     AX,DI           ;    D += AY
                JMP     _3              ;  ENDDO
        ALIGN 4
_X2             DW      ?
_Y2             DW      ?
_5:                                     ;ELSE
                MOV     AX,DI           ;  D = AX - AY / 2
                SHR     AX,1
                NEG     AX
                ADD     AX,SI
_6:                                     ;  DO
                _Plot CX,BP,_Color      ;    PLOT(X,Y)
                CMP     BP,_Y2
                JE      _8              ;  UNTIL Y = Y2
                OR      AX,AX
                JS      _7              ;    IF D >= 0
                ADD     CX,DX           ;      X += SX
                SUB     AX,DI           ;      D -= AY
_7:                                     ;    ENDIF
                ADD     BP,BX           ;    Y += SY
                ADD     AX,SI           ;    D += AX
                JMP     _6              ;  ENDDO
_8:                                     ;ENDIF
        ENDM
;------------------------------------------------------------------------------
PLOT            MACRO   _X,_Y,_C
        LOCAL   _1

                CMP     _Y,Sorok
                JNB     _1
                CMP     _X,Sorhossz
                JNB     _1
                PUSH    DI AX
                IMUL    DI,_Y,Sorhossz
                ADD     DI,_X
                MOV     AL,_C
                STOSB
                POP     AX DI
_1:
ENDM

LINE:           DrawLine PLOT,SZIN
                RETN
;------------------------------------------------------------------------------

Vector          STRUC           ;;Trbeli vektor struktrja
X               DD      ?       ;;X koordinta
Y               DD      ?       ;;Y koordinta
Z               DD      ?       ;;Z koordinta
Vector          ENDS

FAZISX          DW      0
FAZISY          DW      0
SUGARX          DD      160.0
SUGARY          DD      100.0

Const063        DD      063.0
Const100        DD      180.0
Const150        DD      190.0

PIVOT           Vector<200.0,-200.0,-100.0>   ; Az objektum illesztsi pontja

DIST            DD      256.0           ; Kptvolsg

ALFA            DW      0               ; Forgatsi szg X tengely krl
BETA            DW      0               ; Forgatsi szg Y tengely krl
GAMMA           DW      0               ; Forgatsi szg Z tengely krl

XX              DW      ?               ; X koordinta transzformlt kpe
YY              DW      ?               ; Y koordinta transzformlt kpe
ZZ              DW      ?               ; Z koordinta transzformlt kpe

PONTOK LABEL DWORD                      ; Az objektum cme
INCLUDE CUBE.INC                        ; Vagy egy kocka

COUNT           DD      SINLEN/2
TRASH           DD      ?
SINTAB          DD      SINLEN+SINLEN/4 DUP(?)

PAL             DB      768 DUP(?)
SZIN            DB      ?

Code16 ENDS
END START
