Comment /* Pontokbl ll trbeli objektum elforgatsa, eltolsa, majd
           lekpzse a skra (a kpernyre). */

SINLEN = 1024
Sorhossz = 320
Sorok = 200
.486
LOCALS
Code16 SEGMENT USE16
ASSUME CS:Code16, DS:Code16
                ORG 100H
START:
                MOV     AX,13H
                INT     10H
                MOV     AX,0A000H
                MOV     ES,AX

                MOV     CX,SINLEN+SINLEN/4      ;Szinusz tblzat generlsa
                MOV     SI,OFFSET SINTAB        ;   -1.0 s +1.0 kz es
                FNINIT                          ;  lebegpontos rtkekkel
                FLDPI
                FIDIV   COUNT
                FLDZ
@@1:
                FLD     ST
                FSIN
                FSTP    DWORD PTR [SI]
                FADD    ST,ST(1)
                ADD     SI,4
                LOOP    @@1
                FSTP    TRASH
                FSTP    TRASH

                MOV     BP,OFFSET PONTOK
@@2:
                MOV     DX,3DAh         ; Vrakozs a kperny rajzolsra
@@3:
                IN      AL,DX
                TEST    AL,8
                JZ      @@3
@@4:
                IN      AL,DX
                TEST    AL,1
                JZ      @@4

                CALL    HATTER
                                        ; Pontok kirajzolsa
                MOV     SI,BP           ; Objektum cme
                MOV     ECX,[SI]        ; Objektum pontjainak a szma
                ADD     SI,4
@@5:                                    ; Egy pont kirajzolsa
                FLD     [SI.X]  ;; X1   ; Forgats

                MOV     BX,ALFA         ; X tengely krl ALFA-val
                FLD     SINTAB[BX]
                FLD     SINTAB[BX+SINLEN]

                FLD     [SI.Y]  ;; Y0  COS(a)  SIN(a)  X1
                FMUL    ST,ST(1);; Y0*COS(a)  COS(a)  SIN(a)  X1
                FLD     [SI.Z]  ;; Z0  Y0*COS(a)  COS(a)  SIN(a)  X1
                FMUL    ST,ST(3);; Z0*SIN(a)  Y0*COS(a)  COS(a)  SIN(a)  X1
                FSUBP   ST(1),ST;; Y1  COS(a)  SIN(a)  X1
                FXCH    ST(2)   ;; SIN(a)  COS(a)  Y1  X1
                FMUL    [SI.Y]  ;; Y0*SIN(a)  COS(a)  Y1  X1
                FXCH    ST(1)   ;; COS(a)  Y0*SIN(a)  Y1  X1
                FMUL    [SI.Z]  ;; Z0*COS(a)  Y0*SIN(a)  Y1  X1
                FADDP   ST(1),ST;; Z1  Y1  X1

                MOV     BX,BETA         ; Y tengely krl BETA-val
                FLD     SINTAB[BX]
                FLD     SINTAB[BX+SINLEN]

                FLD     ST(4)   ;; X1  COS(_Y*Rad)  SIN(_Y*Rad)  Z1  Y1  X1
                FMUL    ST,ST(1);; X1*COS(_Y*Rad)  COS(_Y*Rad)  SIN(_Y*Rad)  Z1  Y1  X1
                FLD     ST(3)   ;; Z1  X1*COS(_Y*Rad)  COS(_Y*Rad)  SIN(_Y*Rad)  Z1  Y1  X1
                FMUL    ST,ST(3);; Z1*SIN(_Y*Rad)  X1*COS(_Y*Rad)  COS(_Y*Rad)  SIN(_Y*Rad)  Z1  Y1  X1
                FADD            ;; X2  COS(_Y*Rad)  SIN(_Y*Rad)  Z1  Y2  X1
                FXCH    ST(2)   ;; SIN(_Y*Rad)  COS(_Y*Rad)  X2  Z1  Y2  X1
                FMULP   ST(5),ST;; COS(_Y*Rad)  X2  Z1  Y2  X1*SIN(_Y*Rad)
                FMULP   ST(2),ST;; X2  Z1*COS(_Y*Rad)  Y2  X1*SIN(_Y*Rad)
                FXCH            ;; Z1*COS(_Y*Rad)  X2  Y2  X1*SIN(_Y*Rad)
                FSUBRP  ST(3),ST;; X2  Y2  Z2

                MOV     BX,GAMMA        ; Z tengely krl GAMMA-val
                FLD     SINTAB[BX]
                FLD     SINTAB[BX+SINLEN]

                FLD     ST(2)   ;; X2  COS(_Z*Rad)  SIN(_Z*Rad)  X2  Y2  Z2
                FMUL    ST,ST(1);; X2*COS(_Z*Rad)  COS(_Z*Rad)  SIN(_Z*Rad)  X2  Y2  Z2
                FLD     ST(4)   ;; Y2  X2*COS(_Z*Rad)  COS(_Z*Rad)  SIN(_Z*Rad)  X2  Y2  Z2
                FMUL    ST,ST(3);; Y2*SIN(_Z*Rad)  X2*COS(_Z*Rad)  COS(_Z*Rad)  SIN(_Z*Rad)  X2  Y2  Z2
                FSUBP   ST(1),ST;; X3  COS(_Z*Rad)  SIN(_Z*Rad)  X2  Y2  Z2
                FXCH    ST(3)   ;; X2  COS(_Z*Rad)  SIN(_Z*Rad)  X3  Y2  Z2
                FMULP   ST(2),ST;; COS(_Z*Rad)  X2*SIN(_Z*Rad)  X3  Y2  Z2
                FMULP   ST(3),ST;; X2*SIN(_Z*Rad)  X3  Y2*COS(_Z*Rad)  Z2
                FADDP   ST(2),ST;; X3  Y3  Z3

                FLD     PIVOT.Z ;; PZ  X3  Y3  Z3       ;Eltols
                FADDP   ST(3),ST;; X3  Y3  Z4
                FLD     PIVOT.Y ;; PY  X3  Y3  Z4
                FADDP   ST(2),ST;; X3  Y4  Z4
                FADD    PIVOT.X ;; X4  Y4  Z4

                FMUL    DIST    ;; DIST*X4  Y4  Z4      ;Perspektvikus vetts
                FLD     DIST    ;; DIST  DIST*X4  Y4  Z4
                FSUB    ST,ST(3);; DIST-Z4  DIST*X4  Y4  Z4
                FDIVP   ST(1),ST;; XX  Y4  Z4
                FISTP   XX      ;; Y4  Z4

                FMUL    DIST    ;; DIST*Y4  Z4
                FLD     DIST    ;; DIST  DIST*Y4  Z4
                FSUB    ST,ST(2);; DIST-Z4  DIST*Y4  Z4
                FDIVP   ST(1),ST;; YY  Z4
                FISTP   YY      ;; ZZ   

                FADD    Const150
                FDIV    Const100
                FMUL    Const063

                FISTP   ZZ      ;; -

                ADD     XX,Sorhossz/2           ; Kzpre igazts
                ADD     YY,Sorok/2

                CMP     YY,Sorok                ; Vgs
                JNB     @@6
                CMP     XX,Sorhossz
                JNB     @@6

                IMUL    DI,YY,Sorhossz          ; Kirajzols a kpernyre
                ADD     DI,XX

                PUSH    CX SI
                MOV     BX,WORD PTR ZZ
                ADD     BX,BX
                MOV     SI,GOLOK[BX]
                INC     BX
                IMUL    BX,BX,321
                SUB     DI,BX
                CALL    SPRITE
                POP     SI CX
@@6:
                ADD     SI,SIZE Vector          ; Lps a kvetkez pontra
                DEC     ECX
                JNZ     @@5

                LEA     SI,SZIV
                MOV     DI,95*SORHOSSZ+155
                CALL    SPRITE

                ADD     ALFA,8                  ; j ALFA
                ADD     BETA,0;12                 ; j BETA
                ADD     GAMMA,0;20                ; j GAMMA
                AND     ALFA,4*SINLEN-4
                AND     BETA,4*SINLEN-4
                AND     GAMMA,4*SINLEN-4

                ADD     FAZIS,16
                AND     FAZIS,4*SINLEN/2-4
                MOV     BX,FAZIS
                FLD     SINTAB[BX]
                FMUL    SZORZO
                FSUBR   TETO
                FSTP    PIVOT.Y

                MOV     AH,1                    ; Ha nem trtnt billenty
                INT     16H                     ; nyoms, akkor jabb fzis
                JZ      @@2

KILEP:
                MOV     AH,0                    ; Kilps a programbl
                INT     16H

                CALL    SOTETIT

                MOV     AX,3
                INT     10H
                EXITCODE 0
;------------------------------------------------------------------------------
HATTER:
                SUB     DI,DI
                MOV     CX,200*Sorhossz/2
                SUB     AX,AX
                REP     STOSW
                RETN
;------------------------------------------------------------------------------
SPRITE:
                LODSW
                MOV     CL,AL
@@1:
                MOV     CH,AH
                PUSH    DI
@@2:
                LODSB
                TEST    AL,AL
                JZ      @@3
                MOV     ES:[DI],AL
@@3:
                INC     DI
                DEC     CH
                JNZ     @@2
                POP     DI
                ADD     DI,SORHOSSZ
                LOOP    @@1
                RETN
;------------------------------------------------------------------------------
SOTETIT:
                MOV     SI,OFFSET PAL; Sznek eltrolsa
                MOV     DX,3C7H
                MOV     AL,0
                OUT     DX,AL
                ADD     DX,2
                MOV     CX,768
@@3:
                IN      AL,DX
                MOV     [SI],AL
                INC     SI
                LOOP    @@3

                MOV     BX,1            ; Levonand = 0, irny = +1
@@4:
                MOV     DI,63           ; 63 fzisonknt irny csere
@@4B:
                MOV     DX,3DAH
@@5:
                IN      AL,DX
                TEST    AL,8
                JNZ     @@5
@@6:
                IN      AL,DX
                TEST    AL,8
                JZ      @@6

                MOV     SI,OFFSET PAL; Aktulis paletta belltsa
                MOV     DX,3C8H
                MOV     AL,0
                OUT     DX,AL
                INC     DX
                MOV     CX,768
@@7:
                LODSB
                SUB     AL,BH           ; A konponens rtkbl levonunk
                JNS     @@8
                MOV     AL,0            ; Negatv rtk helyett 0
@@8:
                OUT     DX,AL
                LOOP    @@7             ; Kvetkez komponens
                ADD     BH,BL           ; Levonand lptetse
                DEC     DI
                JNZ     @@4B
                RETN
;------------------------------------------------------------------------------

Vector          STRUC           ;;Trbeli vektor struktrja
X               DD      ?       ;;X koordinta
Y               DD      ?       ;;Y koordinta
Z               DD      ?       ;;Z koordinta
Vector          ENDS
;------------------------------------------------------------------------------
SZIV            DB      09,11
                DB      0,0,4,4,0,0,0,4,4,0,0
                DB      0,4,4,4,4,0,4,4,4,4,0
                DB      4,4,4,4,4,4,4,4,4,4,4
                DB      4,4,4,4,4,4,4,4,4,4,4
                DB      0,4,4,4,4,4,4,4,4,4,0
                DB      0,0,4,4,4,4,4,4,4,0,0
                DB      0,0,0,0,4,4,4,0,0,0,0
                DB      0,0,0,0,0,4,0,0,0,0,0
                DB      0,0,0,0,0,4,0,0,0,0,0
;------------------------------------------------------------------------------
GOLOK           DW      OFFSET GOLO1
                DW      OFFSET GOLO3
                DW      OFFSET GOLO5
                DW      OFFSET GOLO7
GOLO1           DB      1,1
                DB      31
GOLO3           DB      3,3
                DB      22,27,22
                DB      27,31,27
                DB      22,27,22
GOLO5           DB      5,5
                DB      00,20,23,20,00
                DB      20,26,28,26,20
                DB      23,28,31,28,23
                DB      20,26,28,26,20
                DB      00,20,23,20,00
GOLO7           DB      7,7
                DB      00,00,18,20,18,00,00
                DB      00,18,24,26,24,18,00
                DB      18,24,28,30,28,24,18
                DB      20,26,30,31,30,26,20
                DB      18,24,28,30,28,24,18
                DB      00,18,24,26,24,18,00
                DB      00,00,18,20,18,00,00
;------------------------------------------------------------------------------
FAZIS           DW      0
SZORZO          DD      120.0
TETO            DD      60.0

Const063        DD      003.6
Const100        DD      180.0
Const150        DD      190.0

PIVOT           Vector<0.0,0.0,-100.0>   ; Az objektum illesztsi pontja

DIST            DD      256.0           ; Kptvolsg

ALFA            DW      0               ; Forgatsi szg X tengely krl
BETA            DW      0               ; Forgatsi szg Y tengely krl
GAMMA           DW      0               ; Forgatsi szg Z tengely krl

XX              DW      ?               ; X koordinta transzformlt kpe
YY              DW      ?               ; Y koordinta transzformlt kpe
ZZ              DW      ?               ; Z koordinta transzformlt kpe

PONTOK LABEL DWORD                      ; Az objektum cme
INCLUDE CUBE.INC                        ; Vagy egy kocka

COUNT           DD      SINLEN/2
TRASH           DD      ?
SINTAB          DD      SINLEN+SINLEN/4 DUP(?)

PAL             DB      768 DUP(?)
SZIN            DB      ?

Code16 ENDS
END START
