;AZ EREDETI, 256 SZIN VGA PALETTA FELETT MOZG SZRKE HENGER
P               SEGMENT
                ASSUME CS:P,DS:P
                ORG 100H

KESIK MACRO _IDO
LOCAL @ELSO,@MASODIK
                PUSH    AX CX DX
                MOV     CX,_IDO
                MOV     DX,3DAH
@ELSO:
                IN      AL,DX
                TEST    AL,8
                JZ      @ELSO
@MASODIK:
                IN      AL,DX
                TEST    AL,1
                JZ      @MASODIK
                DEC     CX
                JNZ     @ELSO
                POP     DX CX AX
ENDM

SZIN_VISSZA MACRO
                PUSH    AX
                MOV     AL,AH
                XOR     AH,AH
                DEC     DX
                OUT     DX,AL
                INC     DX
                MOV     BL,3
                MUL     BL
                MOV     SI,OFFSET PAL
                ADD     SI,AX
                MOV     AL,[SI.R]
                OUT     DX,AL
                MOV     AL,[SI.G]
                OUT     DX,AL
                MOV     AL,[SI.B]
                OUT     DX,AL
                POP     AX
ENDM

START:
LOCALS
JUMPS
                MOV     AX,13H
                INT     10H
                MOV     AX,0A000H
                MOV     ES,AX

PALETTA_MENT:
                MOV     DX,3C8H
                MOV     AL,0
                OUT     DX,AL
                INC     DX
                MOV     DI,OFFSET PAL
                MOV     CX,256
@@C1:
                IN      AL,DX
                MOV     [DI.R],AL
                IN      AL,DX
                MOV     [DI.G],AL
                IN      AL,DX
                MOV     [DI.B],AL
                ADD     DI,SIZE COLOR
                DEC     CX
                JNZ     @@C1

KEZDORAJZ:
                MOV     DI,0
                MOV     CX,200
@@C2:
                PUSH    CX
                MOV     AL,0
                MOV     CX,256
@@C1:
                MOV     ES:[DI],AL
                INC     AL
                INC     DI
                DEC     CX
                JNZ     @@C1
                ADD     DI,320-256
                POP     CX
                DEC     CX
                JNZ     @@C2

                MOV     AX,0
                INT     16H

                MOV     AH,0
PALETTA_ODA:
                KESIK 50
                MOV     DX,3C8H
                MOV     AL,AH
                OUT     DX,AL
                INC     DX
                MOV     AL,0
                MOV     CX,63
@@C1:
                OUT     DX,AL
                OUT     DX,AL
                OUT     DX,AL
                INC     AL
                DEC     CX
                JNZ     @@C1
                MOV     CX,64
@@C2:
                OUT     DX,AL
                OUT     DX,AL
                OUT     DX,AL
                DEC     AL
                DEC     CX
                JNZ     @@C2

                SZIN_VISSZA

                INC     AH
                CMP     AH,129
                JNZ     PALETTA_ODA

PALETTA_VISSZA:
                KESIK 50
                MOV     DX,3C8H
                MOV     AL,AH
                OUT     DX,AL
                INC     DX
                MOV     AL,0
                MOV     CX,63
@@C1:
                OUT     DX,AL
                OUT     DX,AL
                OUT     DX,AL
                INC     AL
                DEC     CX
                JNZ     @@C1
                MOV     CX,64
@@C2:
                OUT     DX,AL
                OUT     DX,AL
                OUT     DX,AL
                DEC     AL
                DEC     CX
                JNZ     @@C2

                ADD     AH,128
                SZIN_VISSZA
                SUB     AH,129

                JNZ     PALETTA_VISSZA

                MOV     AH,1
                INT     16H
                MOV     AH,0
                JZ     PALETTA_ODA

KILEPES:
                MOV     AX,3
                INT     10H
                EXITCODE 0

COLOR           STRUC
R               DB 63
G               DB 0
B               DB 0
ENDS

PAL             COLOR 256 DUP(<>)

ENDS            P
END             START