Comment /* Sprite mozgatsa krplyn (ld p02h.asm) */

SINLEN = 64                             ; Elg 64 rtk (pozici) is

Sorhossz = 320
.486
LOCALS
Code16 SEGMENT USE16
ASSUME CS:Code16, DS:Code16
                ORG 100H
START:
                MOV     AX,13H
                INT     10H
                MOV     AX,0A000H
                MOV     ES,AX
                FNINIT
                MOV     CX,SINLEN
                MOV     SI,OFFSET XSINTAB
                FLDPI
                FIDIV   COUNT
                FLDZ
@@0:
                FLD     ST
                FSIN
                FADD    PLUS1
                FMUL    RX
                FISTP   WORD PTR [SI]
                FADD    ST,ST(1)
                ADD     SI,2
                LOOP    @@0
                FSTP    TRASH
                FSTP    TRASH
                MOV     CX,SINLEN
                MOV     SI,OFFSET YSINTAB
                FLDPI
                FIDIV   COUNT
                FLDZ
@@1:
                FLD     ST
                FSIN
                FADD    PLUS1
                FMUL    RY
                FISTP   WORD PTR [SI]
                FADD    ST,ST(1)
                ADD     SI,2
                LOOP    @@1
                FSTP    TRASH
                FSTP    TRASH

                MOV     DX,3C8H         ; A sprite szneinek belltsa
                MOV     AL,0
                OUT     DX,AL
                INC     DX
                MOV     SI,OFFSET GPAL
                MOV     CX,256*3
                REP     OUTSB

                MOV     CX,SINLEN
@@2:
                MOV     DX,3DAH         ; Vrakozs kpernyvltsra
@@3:
                IN      AL,DX
                TEST    AL,8
                JNZ     @@3
@@4:
                IN      AL,DX
                TEST    AL,8
                JZ      @@4

                ADD     BX,2            ; Szinusz mutatjt lptetjk
                AND     BX,2*SINLEN-2   ; Szinusz mutatjt normljuk
                MOV     AX,Sorhossz
                MUL     WORD PTR YSINTAB[BX]
                MOV     SI,BX           ; Koszinusz mutatjt kiszmoljuk
                ADD     SI,SINLEN/2
                AND     SI,2*SINLEN-2   ; Koszinusz mutatjt normljuk
                ADD     AX,XSINTAB[SI]
                ADD     AX,45           ; Betoljuk a kperny kzepre
                MOV     DI,AX           ; DI = kiszmolt pozici

                MOV     SI,OFFSET GRAW  ; Sprite kirajzolsa DI pozicira
                MOV     CX,63
@@5:
                PUSH    CX
                PUSH    DI
                MOV     CX,62
                REP     MOVSB
                POP     DI
                ADD     DI,Sorhossz
                POP     CX
                LOOP    @@5
                MOV     AH,1
                INT     16H             ; Ha a billentyzet puffer res,
                JZ      @@2             ; akkor jabb rajzols

                MOV     AH,0
                INT     16H
                MOV     AX,3
                INT     10H
                EXITCODE 0

GPAL:           INCLUDE GOLOPAL.INC     ; A sprite szneinek adatai
GRAW:           INCLUDE GOLORAW.INC     ; A sprite formjnak adatai

RX              DD      80.4            ; A krplya x irny sugara
RY              DD      67.0            ; A krplya y irny sugara

COUNT           DD      SINLEN/2
PLUS1           DD      1.0
TRASH           DD      ?
XSINTAB         DW      SINLEN DUP(?)
YSINTAB         DW      SINLEN DUP(?)

Code16 ENDS
END START
