Comment /* Lissajous grbe rajzolsa szinusz tblzatokkal
           (ld. p03c.asm) */

SINLEN = 512
Sorhossz = 320
.486
LOCALS
Code16 SEGMENT USE16
ASSUME CS:Code16, DS:Code16
                ORG 100H
START:
                MOV     AX,13H
                INT     10H
                MOV     AX,0A000H
                MOV     ES,AX
                FNINIT
                MOV     CX,SINLEN
                MOV     SI,OFFSET XSINTAB
                FLDPI
                FIDIV   COUNT
                FLDZ
@@0:
                FLD     ST
                FSIN
                FADD    PLUS1
                FMUL    RX
                FISTP   WORD PTR [SI]
                FADD    ST,ST(1)
                ADD     SI,2
                LOOP    @@0
                FSTP    TRASH
                FSTP    TRASH
                MOV     CX,SINLEN
                MOV     SI,OFFSET YSINTAB
                FLDPI
                FIDIV   COUNT
                FLDZ
@@1:
                FLD     ST
                FSIN
                FADD    PLUS1
                FMUL    RY
                FISTP   WORD PTR [SI]
                FADD    ST,ST(1)
                ADD     SI,2
                LOOP    @@1
                FSTP    TRASH
                FSTP    TRASH

                SUB     BX,BX
                MOV     SI,SINLEN/4     ; deltaFI = PI/4

                MOV     CX,SINLEN
@@2:
                MOV     AX,Sorhossz
                MUL     WORD PTR YSINTAB[SI]
                ADD     AX,XSINTAB[BX]
                MOV     DI,AX
                MOV     BYTE PTR ES:[DI],15

                ADD     BX,2
                ADD     SI,4            ; Frekvenciaarny: 1:2

                AND     SI,2*SINLEN-2
                AND     BX,2*SINLEN-2
                LOOP    @@2
                MOV     AH,0
                INT     16H
                MOV     AX,3
                INT     10H
                EXITCODE 0

RX              DD      159.5           ; A grbe x irny sugara
RY              DD      99.5            ; A grbe y irny sugara

COUNT           DD      SINLEN/2
PLUS1           DD      1.0
TRASH           DD      ?
XSINTAB         DW      SINLEN DUP(?)
YSINTAB         DW      SINLEN DUP(?)

Code16 ENDS
END START
