Comment /* Szinusz tblzat generlsa ltalnos hosszal, kr kirajzolsa */

SINLEN = 128                            ; A SINTAB hossz 512 lesz

Sorhossz = 320
szindb=128
szin1=1
.486
LOCALS
Code16 SEGMENT USE16
ASSUME CS:Code16
                ORG 100H

include alap_ati.mac
START:
                MOV     AX,13H
                INT     10H
                MOV     AX,0A000H
                MOV     ES,AX

                MOV     CX,SINLEN       ; SINLEN hossz lesz a tblzatunk

                MOV     SI,OFFSET SINTAB
                FNINIT
                FLDPI

                FIDIV   COUNT           ; Step = PI/(SINLEN/2)

                FLDZ
@@1:
                FLD     ST
                FSIN
                FADD    PLUS1
                FMUL    AMPL
                FISTP   WORD PTR [SI]
                FADD    ST,ST(1)
                ADD     SI,2
                LOOP    @@1
                FSTP    TRASH
                FSTP    TRASH

comment ~
                mov dx,3c8h
                mov al,0
                out dx,al
                inc dx
                mov cx,63
@@4:
                out dx,al
                out dx,al
                out dx,al
                inc ax
                loop @@4
                out dx,al
                out dx,al
                out dx,al
                mov cx,64
@@5:
                out dx,al
                out dx,al
                out dx,al
                dec ax
                loop @@5
~
                xor di,di
                sub si,si
                xor bx,bx
                sub bp,bp
                mov cx,200
@@2:
                push cx si bp bx
                mov cx,320
@@3:
                mov ax,sintab[si]
                add ax,sintab[bp]
                add ax,sintab[bx]
                inc ax ;a nulladik szin soha nem kerl a kpernyre
                stosb
                add si,2
                and si,2*sinlen-2
                add bx,4
                and bx,2*sinlen-2
                add bp,6
                and bp,2*sinlen-2
                loop @@3
                pop bx bp si cx
                add si,10
                and si,2*sinlen-2
                add bx,4
                and bx,2*sinlen-2
                add bp,8
                and bp,2*sinlen-2


                loop @@2

ciklus:
                delay 1
                inc bp
                cmp bp,szindb
                jb c1
                sub bp,bp
c1:
                mov si,offset pal
                mov dx,3c8h
                mov ax,bp
                add al,szin1
                out dx,al
                inc dx
                mov cx,szindb*3
                sub cx,bp
                sub cx,bp
                sub cx,bp
                rep outsb
                dec dx
                mov al,szin1
                out dx,al
                inc dx
                mov cx,bp
                add cx,bp
                add cx,bp
                rep outsb
                mov ah,1
                int 16h
                jz ciklus

                MOV     AH,0
                INT     16H
                MOV     AX,3
                INT     10H
                EXITCODE 0

_R = 63
_G = 63
_B = 0
pal:
        rept 63
             db _R,_G,_B
        _R=_R-1
        _G=_G-1
        _B=_B+1
        endm
        db _R,_G,_B
        rept 64
             db _R,_G,_B
        _R=_R+1
        _G=_G+1
        _B=_B-1
        endm

COUNT           DD      SINLEN/2        ; Pi-ig SINLEN/2 szget trolunk le

PLUS1           DD      1.0
AMPL            DD      21.0
TRASH           DD      ?

SINTAB          DW      SINLEN DUP(?)   ; A tblzat helye (SINLEN db WORD)

Code16 ENDS
END START
