Comment /* Vletlen pozicikban vletlen sznek kigyjtsa gombnyomsig,
           makrk definilsa */

Sorhossz = 320

RandInit        MACRO                   ;;Vletlenszm init makr fejlce
        LOCAL   _1                      ;;A makr loklis cmkinek felsorolsa

                XOR     AX,AX           ;;Timer szmll lekrdezse
                OUT     43H,AL
                MOV     ES,AX
                IN      AL,40H
                ROR     EAX,8
                IN      AL,40H
                ROR     EAX,8
                MOV     AX,[ES:46CH]    ;;Bekapcsolstol eltelt id lekrdezse
                MOV     SEED,EAX        ;;A szmllk adjk SEED kezdrtkt
                JMP     _1              ;;SEED adat tlpse
        ALIGN 4                         ;;Igazts DWORD hatrra
SEED            DD      ?               ;;A vletlenszmok sornak akt. eleme
_1:
ENDM

RandInt         MACRO                   ;;Linear-congruential Method
                                        ;;      a <- a * b + c mod m
                MOV     EAX,SEED
                MOV     EDX,31415621    ;;recommended constant by Tom Swan
                INC     EAX
                MUL     EDX
                MOV     SEED,EAX
ENDM

RandRange       MACRO   Range           ;;A makr formlis paramtere a Range

                RandInt                 ;;Vletlenszm EAX-be
                MOV     EDX,Range
                SHR     EAX,16          ;;EAX/65536
                MUL     EDX             ;;Range*EAX/65536
                MOV     AX,DX           ;;Range*EAX/65536/65536
                ROR     EAX,16          ;;Vletlenszm EAX-be
ENDM

.486
LOCALS
Code16 SEGMENT USE16
ASSUME CS:Code16, DS:Code16
                ORG 100H
START:
                RandInit                ; A vletlenszm generl initje

                MOV     AX,13H
                INT     10H
                MOV     AX,0A000H
                MOV     ES,AX
@@1:
                RandRange 200           ; Vletlenszm: 0 <= y < 200
                IMUL    DI,AX,320       ; Szorozzuk a sor hosszaval
                RandRange 320           ; Vletlenszm: 0 <= x < 320
                ADD     DI,AX           ; DI: y*Sorhossz+x
                RandRange 256           ; Vletlenszm: 0 <= szin < 256

                MOV     ES:[DI],AL
                MOV     AH,1
                INT     16H
                JZ      @@1
                MOV     AH,0
                INT     16H
                MOV     AX,3
                INT     10H
                EXITCODE 0
Code16 ENDS
END START
