maxcolor    EQU 128
fstcolor    EQU 32
nulcolor    EQU 0

.486
LOCALS
Code16 SEGMENT USE16
ASSUME CS:Code16, DS:Code16
                ORG 100H
START:
                MOV     AX,13H
                INT     10H
                MOV     AX,0A000H
                MOV     ES,AX

                MOV     AX,13H
                INT     10H
                PUSH    0A000H
                POP     ES

                FNINIT
                FLD     QWORD PTR is    ; is
                FLD     QWORD PTR ai    ; ai  is
                FLD     QWORD PTR ar    ; ar  ai  is
main:
                SUB     EDI,EDI
loopy:
                MOV     EBP,320
loopx:
                SUB     ECX,ECX
;r2 = 0
                FLDZ                    ; r2  ar  ai  is
;i2 = 0
                FLD     ST              ; i2  r2  ar  ai  is
;zi = 0
                FLD     ST              ; zi  i2  r2  ar  ai  is
;zr = 0
                FLD     ST              ; zr  zi  i2  r2  ar  ai  is
iter:
;zi = 2*zr*zi+ai
                FMULP   ST(1),ST        ; zr*zi  i2  r2  ar  ai  is
                FADD    ST,ST(0)        ; 2*zr*zi  i2  r2  ar  ai  is
                FADD    ST,ST(4)        ; zi  i2  r2  ar  ai  is
;zr = r2-i2+ar
                FXCH    ST(2)           ; r2  i2  zi  ar  ai  is
                FADD    ST,ST(3)        ; r2+ar  i2  zi  ar  ai  is
                FSUBRP  ST(1),ST        ; zr  zi  ar  ai  is
;r2 = zr*zr
                FLD     ST              ; zr  zr  zi  ar  ai  is
                FMUL    ST,ST(1)        ; r2  zr  zi  ar  ai  is
                FXCH    ST(2)           ; zi  zr  r2  ar  ai  is
;i2 = zi*zi
                FLD     ST              ; zi  zi  zr  r2  ar  ai  is
                FMUL    ST,ST(1)        ; i2  zi  zr  r2  ar  ai  is
                FXCH    ST(2)           ; zr  zi  i2  r2  ar  ai  is
;i2+r2 < 4.0
                FLD     ST(3)           ; r2  zr  zi  i2  r2  ar  ai  is
                FADD    ST,ST(3)        ; i2+r2  zr  zi  i2  r2  ar  ai  is
                FCOMP   Plus4           ; zr  zi  i2  r2  ar  ai  is
                FNSTSW  AX
                SAHF
                JA      iter2
                INC     ECX
                CMP     ECX,maxiter
                JNE     iter
                MOV     CL,nulcolor
                JMP     iter3
iter2:
                AND     CL,maxcolor-1
                ADD     CL,fstcolor
iter3:
                MOV     ES:[EDI],CL
                INC     EDI
                FSTP    TRASH           ; zi  i2  r2  ar  ai  is
                FSTP    TRASH           ; i2  r2  ar  ai  is
                FSTP    TRASH           ; r2  ar  ai  is
                FSTP    TRASH           ; ar  ai  is
;ar = ar+is
                FADD    ST,ST(2)
                DEC     EBP
                JNZ     loopx
;ai = ai+is
                FLD     ST(2)           ; is  ar  ai  is
                FADD    ST(2),ST        ; is  ar  ai  is
                FMUL    maxx            ; maxx*is  ar  ai  is
                FSUBP   ST(1),ST        ; ar  ai  is
                CMP     EDI,64000
                JB      loopy
                FLD     ST(2)           ; is  ar  ai  is
                FMUL    maxy            ; maxy*is  ar  ai  is
                FSUBP   ST(2),ST        ; ar  ai  is
                MOV     AH,0
                INT     16H
                CMP     AH,50H
                JNE     @@1
                FLD     ST(2)           ; is  ar  ai  is
                FMUL    Trans           ; Tr*is  ar  ai  is
                FADDP   ST(2),ST        ; ar  ai  is
                JMP     main
@@1:
                CMP     AH,48H
                JNE     @@2
                FLD     ST(2)           ; is  ar  ai  is
                FMUL    Trans           ; Tr*is  ar  ai  is
                FSUBP   ST(2),ST        ; ar  ai  is
                JMP     main
@@2:
                CMP     AH,4BH
                JNE     @@3
                FLD     ST(2)           ; is  ar  ai  is
                FMUL    Trans           ; Tr*is  ar  ai  is
                FSUBP   ST(1),ST        ; ar  ai  is
                JMP     main
@@3:
                CMP     AH,4DH
                JNE     @@4
                FLD     ST(2)           ; is  ar  ai  is
                FMUL    Trans           ; Tr*is  ar  ai  is
                FADDP   ST(1),ST        ; ar  ai  is
                JMP     main
@@4:
                CMP     AH,4AH
                JNE     @@5
                FLD     ST(2)           ; is  ar  ai  is
                FDIV    Scale           ; Sc*is  ar  ai  is
                FXCH    ST(3)           ; is  ar  ai  is*Sc
                FSUB    ST,ST(3)        ; is-is*Sc  ar  ai  is*Sc
                FMUL    HALF            ; d  ar  ai  is
                FLD     ST              ; d  d  ar  ai  is
                FMUL    maxx            ; dr  d  ar  ai  is
                FADDP   ST(2),ST        ; d  ar  ai  is
                FMUL    maxy            ; di  ar  ai  is
                FADDP   ST(2),ST        ; ar  ai  is
                SUB     maxiter,2
                JMP     main
@@5:
                CMP     AH,4EH
                JNE     @@6
                FLD     ST(2)           ; is  ar  ai  is
                FMUL    Scale           ; Sc*is  ar  ai  is
                FXCH    ST(3)           ; is  ar  ai  is*Sc
                FSUB    ST,ST(3)        ; is-is*Sc  ar  ai  is*Sc
                FMUL    HALF            ; d  ar  ai  is
                FLD     ST              ; d  d  ar  ai  is
                FMUL    maxx            ; dr  d  ar  ai  is
                FADDP   ST(2),ST        ; d  ar  ai  is
                FMUL    maxy            ; di  ar  ai  is
                FADDP   ST(2),ST        ; ar  ai  is
                ADD     maxiter,2
                JMP     main
@@6:
                CMP     AH,2
                JNE     @@7
                INC     maxiter
                JMP     main
@@7:
                CMP     AH,3
                JNE     @@8
                DEC     maxiter
                JMP     main
@@8:
                FSTP    QWORD PTR ar    ; ai  is
                FSTP    QWORD PTR ai    ; is
                FSTP    QWORD PTR is    ; -

                MOV     DI,OFFSET Num
                MOV     DWORD PTR [DI],'ixam'
                MOV     DWORD PTR [DI+4],' ret'
                MOV     DWORD PTR [DI+8],' DD '
                ADD     DI,12
                MOV     EAX,maxiter
                CALL    PrintNum
                MOV     WORD PTR [DI],0A0DH
                ADD     DI,2

                MOV     WORD PTR [DI],'ra'
                MOV     DWORD PTR [DI+2],' DD '
                ADD     DI,6
                MOV     EAX,DWORD PTR ar
                CALL    PrintNum
                MOV     BYTE PTR [DI],','
                INC     DI
                MOV     EAX,DWORD PTR ar+4
                CALL    PrintNum
                MOV     WORD PTR [DI],0A0DH
                ADD     DI,2

                MOV     WORD PTR [DI],'ia'
                MOV     DWORD PTR [DI+2],' DD '
                ADD     DI,6
                MOV     EAX,DWORD PTR ai
                CALL    PrintNum
                MOV     BYTE PTR [DI],','
                INC     DI
                MOV     EAX,DWORD PTR ai+4
                CALL    PrintNum
                MOV     WORD PTR [DI],0A0DH
                ADD     DI,2

                MOV     WORD PTR [DI],'si'
                MOV     DWORD PTR [DI+2],' DD '
                ADD     DI,6
                MOV     EAX,DWORD PTR is
                CALL    PrintNum
                MOV     BYTE PTR [DI],','
                INC     DI
                MOV     EAX,DWORD PTR is+4
                CALL    PrintNum

                MOV     DX,OFFSET FName
                MOV     AH,3CH
                INT     21H
                MOV     BX,AX
                MOV     DX,OFFSET Num
                MOV     CX,DI
                SUB     CX,DX
                MOV     AH,40H
                INT     21H
                MOV     AH,3EH
                INT     21H

                MOV     AX,3
                INT     10H
                EXITCODE 0

PrintNum:
                MOV     EBX,10
                SUB     CX,CX
@@1:
                SUB     EDX,EDX
                DIV     EBX
                ADD     DL,'0'
                PUSH    DX
                INC     CX
                TEST    EAX,EAX
                JNZ     @@1
@@2:
                POP     DX
                MOV     [DI],DL
                INC     DI
                LOOP    @@2
                RETN

        ALIGN   16
INCLUDE P07C.INC

maxx            DD  320.0
maxy            DD  200.0

Trans           DD    32.0
Scale           DD    0.75
Plus4           DD    4.0
HALF            DD    0.5
TRASH           DD      ?

FName           DB      'P07C.INC',0
Num             DB      3*31 DUP(?)

Code16 ENDS
END START
