maxcolor    EQU 128
fstcolor    EQU 32
nulcolor    EQU 0

.486
LOCALS
Code16 SEGMENT USE16
ASSUME CS:Code16, DS:Code16
                ORG 100H
START:
                MOV     AX,13H
                INT     10H
                MOV     AX,0A000H
                MOV     ES,AX

                MOV     AX,13H
                INT     10H
                PUSH    0A000H
                POP     ES

;is = xi/maxy
                FLD     xi              ; xi
                FDIV    maxy            ; is
                FLD     ai              ; ai  is
                FLD     ar              ; ar  ai  is
main:
                SUB     EDI,EDI
loopy:
                MOV     EBP,320
loopx:
                SUB     ECX,ECX
;r2 = 0
                FLDZ                    ; r2  ar  ai  is
;i2 = 0
                FLD     ST              ; i2  r2  ar  ai  is
;zi = 0
                FLD     ST              ; zi  i2  r2  ar  ai  is
;zr = 0
                FLD     ST              ; zr  zi  i2  r2  ar  ai  is
iter:
;zi = 2*zr*zi+ai
                FMULP   ST(1),ST        ; zr*zi  i2  r2  ar  ai  is
                FADD    ST,ST(0)        ; 2*zr*zi  i2  r2  ar  ai  is
                FADD    ST,ST(4)        ; zi  i2  r2  ar  ai  is
;zr = r2-i2+ar
                FXCH    ST(2)           ; r2  i2  zi  ar  ai  is
                FADD    ST,ST(3)        ; r2+ar  i2  zi  ar  ai  is
                FSUBRP  ST(1),ST        ; zr  zi  ar  ai  is
;r2 = zr*zr
                FLD     ST              ; zr  zr  zi  ar  ai  is
                FMUL    ST,ST(1)        ; r2  zr  zi  ar  ai  is
                FXCH    ST(2)           ; zi  zr  r2  ar  ai  is
;i2 = zi*zi
                FLD     ST              ; zi  zi  zr  r2  ar  ai  is
                FMUL    ST,ST(1)        ; i2  zi  zr  r2  ar  ai  is
                FXCH    ST(2)           ; zr  zi  i2  r2  ar  ai  is
;i2+r2 < 4.0
                FLD     ST(3)           ; r2  zr  zi  i2  r2  ar  ai  is
                FADD    ST,ST(3)        ; i2+r2  zr  zi  i2  r2  ar  ai  is
                FCOMP   Plus4           ; zr  zi  i2  r2  ar  ai  is
                FNSTSW  AX
                SAHF
                JA      iter2
                INC     ECX
                CMP     ECX,maxiter
                JNE     iter
                MOV     CL,nulcolor
                JMP     iter3
iter2:
                AND     CL,maxcolor-1
                ADD     CL,fstcolor
iter3:
                MOV     ES:[EDI],CL
                INC     EDI
                FSTP    TRASH           ; zi  i2  r2  ar  ai  is
                FSTP    TRASH           ; i2  r2  ar  ai  is
                FSTP    TRASH           ; r2  ar  ai  is
                FSTP    TRASH           ; ar  ai  is
;ar = ar+is
                FADD    ST,ST(2)
                DEC     EBP
                JNZ     loopx
;ai = ai+is
                FLD     ST(2)           ; is  ar  ai  is
                FADD    ST(2),ST        ; is  ar  ai  is
                FMUL    maxx            ; maxx*is  ar  ai  is
                FSUBP   ST(1),ST        ; ar  ai  is
                CMP     EDI,64000
                JB      loopy
                FLD     ST(2)           ; is  ar  ai  is
                FMUL    maxy            ; maxy*is  ar  ai  is
                FSUBP   ST(2),ST        ; ar  ai  is
                MOV     AH,0
                INT     16H
                CMP     AH,50H
                JNE     @@1
                FLD     ST(2)           ; is  ar  ai  is
                FMUL    Trans           ; Tr*is  ar  ai  is
                FADDP   ST(2),ST        ; ar  ai  is
                JMP     main
@@1:
                CMP     AH,48H
                JNE     @@2
                FLD     ST(2)           ; is  ar  ai  is
                FMUL    Trans           ; Tr*is  ar  ai  is
                FSUBP   ST(2),ST        ; ar  ai  is
                JMP     main
@@2:
                CMP     AH,4BH
                JNE     @@3
                FLD     ST(2)           ; is  ar  ai  is
                FMUL    Trans           ; Tr*is  ar  ai  is
                FSUBP   ST(1),ST        ; ar  ai  is
                JMP     main
@@3:
                CMP     AH,4DH
                JNE     @@4
                FLD     ST(2)           ; is  ar  ai  is
                FMUL    Trans           ; Tr*is  ar  ai  is
                FADDP   ST(1),ST        ; ar  ai  is
                JMP     main
@@4:
                CMP     AH,4AH
                JNE     @@5
                FLD     ST(2)           ; is  ar  ai  is
                FDIV    Scale           ; Sc*is  ar  ai  is
                FXCH    ST(3)           ; is  ar  ai  is*Sc
                FSUB    ST,ST(3)        ; is-is*Sc  ar  ai  is*Sc
                FMUL    HALF            ; d  ar  ai  is
                FLD     ST              ; d  d  ar  ai  is
                FMUL    maxx            ; dr  d  ar  ai  is
                FADDP   ST(2),ST        ; d  ar  ai  is
                FMUL    maxy            ; di  ar  ai  is
                FADDP   ST(2),ST        ; ar  ai  is
                SUB     maxiter,2
                JMP     main
@@5:
                CMP     AH,4EH
                JNE     @@6
                FLD     ST(2)           ; is  ar  ai  is
                FMUL    Scale           ; Sc*is  ar  ai  is
                FXCH    ST(3)           ; is  ar  ai  is*Sc
                FSUB    ST,ST(3)        ; is-is*Sc  ar  ai  is*Sc
                FMUL    HALF            ; d  ar  ai  is
                FLD     ST              ; d  d  ar  ai  is
                FMUL    maxx            ; dr  d  ar  ai  is
                FADDP   ST(2),ST        ; d  ar  ai  is
                FMUL    maxy            ; di  ar  ai  is
                FADDP   ST(2),ST        ; ar  ai  is
                ADD     maxiter,2
                JMP     main
@@6:
                CMP     AH,2
                JNE     @@7
                INC     maxiter
                JMP     main
@@7:
                CMP     AH,3
                JNE     @@8
                DEC     maxiter
                JMP     main
@@8:
                FSTP    TRASH           ; ai  is
                FSTP    TRASH           ; is
                FSTP    TRASH           ; -
		mov	si,offset hsipal
		mov	dx,3c7h
		mov	al,0
		out	dx,al
		add	dx,2
		mov	cx,768
_1:
		in	al,dx
		shl	al,2
		mov	[si],al
		inc	si
		loop	_1

		mov	dx,offset hsifile
		xor	cx,cx
		mov	ah,3ch
		int	21h
  		mov	bx,ax
		mov	dx,offset hsihead
		mov	cx,768+32
		mov	ah,40h
		int	21h
		xor	dx,dx
		push	ds
		mov	ax,0a000h
		mov	ds,ax
		mov	cx,64000
		mov	ah,40h
		int	21h
		pop ds
		mov	ah,3eh
		int	21h
                MOV     AX,3
                INT     10H
                EXITCODE 0

        ALIGN   16
maxiter         DD      31

ar              DD   -2.5               ; alpha real (-2.5)
ai              DD   -1.5               ; alpha imag (-1.5)
xi              DD    3.0               ; delta imag (3.0)

maxx            DD  320.0
maxy            DD  200.0

Trans           DD    32.0              ; in pixel
Scale           DD    0.75
Plus4           DD    4.0
HALF            DD    0.5
TRASH           DD      ?
HSIFILE		DB   'KEP01.RAW',0
HSIHEAD DB 6DH, 68H,77H,61H,6EH,68H,00H,04H,01H,40H,00H,0C8H,01H,00H,00H,00H
        DB 00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H
HSIPAL	DB 768 DUP(?)
Code16 ENDS
END START
