Comment /* Pontokbl ll trbeli objektum elforgatsa, eltolsa, majd
           lekpzse a skra (a kpernyre). */

SINLEN = 1024
Sorhossz = 320
Sorok = 200
.486
LOCALS
Code16 SEGMENT USE16
ASSUME CS:Code16, DS:Code16
                ORG 100H
START:
                MOV     AX,13H
                INT     10H
                MOV     AX,0A000H
                MOV     ES,AX

                MOV     CX,SINLEN+SINLEN/4      ;Szinusz tblzat generlsa
                MOV     SI,OFFSET SINTAB        ;   -1.0 s +1.0 kz es
                FNINIT                          ;  lebegpontos rtkekkel
                FLDPI
                FIDIV   COUNT
                FLDZ
@@1:
                FLD     ST
                FSIN
                FSTP    DWORD PTR [SI]
                FADD    ST,ST(1)
                ADD     SI,4
                LOOP    @@1
                FSTP    TRASH
                FSTP    TRASH

@@2:
                MOV     DX,3DAh         ; Vrakozs a kperny rajzolsra
@@3:
                IN      AL,DX
                TEST    AL,8
                JZ      @@3
@@4:
                IN      AL,DX
                TEST    AL,1
                JZ      @@4

                SUB     DI,DI           ; Kperny trlse
                MOV     CX,Sorhossz*Sorok/4
                SUB     EAX,EAX
                REP     STOSD
                                        ; Pontok kirajzolsa
                MOV     SI,OFFSET PONTOK; Objektum cme
                MOV     ECX,[SI]        ; Objektum pontjainak a szma
                ADD     SI,4
@@5:                                    ; Egy pont kirajzolsa
                FLD     [SI.X]  ;; X1   ; Forgats

                MOV     BX,ALFA         ; X tengely krl ALFA-val
                FLD     SINTAB[BX]
                FLD     SINTAB[BX+SINLEN]

                FLD     [SI.Y]  ;; Y0  COS(a)  SIN(a)  X1
                FMUL    ST,ST(1);; Y0*COS(a)  COS(a)  SIN(a)  X1
                FLD     [SI.Z]  ;; Z0  Y0*COS(a)  COS(a)  SIN(a)  X1
                FMUL    ST,ST(3);; Z0*SIN(a)  Y0*COS(a)  COS(a)  SIN(a)  X1
                FSUBP   ST(1),ST;; Y1  COS(a)  SIN(a)  X1
                FXCH    ST(2)   ;; SIN(a)  COS(a)  Y1  X1
                FMUL    [SI.Y]  ;; Y0*SIN(a)  COS(a)  Y1  X1
                FXCH    ST(1)   ;; COS(a)  Y0*SIN(a)  Y1  X1
                FMUL    [SI.Z]  ;; Z0*COS(a)  Y0*SIN(a)  Y1  X1
                FADDP   ST(1),ST;; Z1  Y1  X1

                MOV     BX,BETA         ; Y tengely krl BETA-val
                FLD     SINTAB[BX]
                FLD     SINTAB[BX+SINLEN]

                FLD     ST(4)   ;; X1  COS(_Y*Rad)  SIN(_Y*Rad)  Z1  Y1  X1
                FMUL    ST,ST(1);; X1*COS(_Y*Rad)  COS(_Y*Rad)  SIN(_Y*Rad)  Z1  Y1  X1
                FLD     ST(3)   ;; Z1  X1*COS(_Y*Rad)  COS(_Y*Rad)  SIN(_Y*Rad)  Z1  Y1  X1
                FMUL    ST,ST(3);; Z1*SIN(_Y*Rad)  X1*COS(_Y*Rad)  COS(_Y*Rad)  SIN(_Y*Rad)  Z1  Y1  X1
                FADD            ;; X2  COS(_Y*Rad)  SIN(_Y*Rad)  Z1  Y2  X1
                FXCH    ST(2)   ;; SIN(_Y*Rad)  COS(_Y*Rad)  X2  Z1  Y2  X1
                FMULP   ST(5),ST;; COS(_Y*Rad)  X2  Z1  Y2  X1*SIN(_Y*Rad)
                FMULP   ST(2),ST;; X2  Z1*COS(_Y*Rad)  Y2  X1*SIN(_Y*Rad)
                FXCH            ;; Z1*COS(_Y*Rad)  X2  Y2  X1*SIN(_Y*Rad)
                FSUBRP  ST(3),ST;; X2  Y2  Z2

                MOV     BX,GAMMA        ; Z tengely krl GAMMA-val
                FLD     SINTAB[BX]
                FLD     SINTAB[BX+SINLEN]

                FLD     ST(2)   ;; X2  COS(_Z*Rad)  SIN(_Z*Rad)  X2  Y2  Z2
                FMUL    ST,ST(1);; X2*COS(_Z*Rad)  COS(_Z*Rad)  SIN(_Z*Rad)  X2  Y2  Z2
                FLD     ST(4)   ;; Y2  X2*COS(_Z*Rad)  COS(_Z*Rad)  SIN(_Z*Rad)  X2  Y2  Z2
                FMUL    ST,ST(3);; Y2*SIN(_Z*Rad)  X2*COS(_Z*Rad)  COS(_Z*Rad)  SIN(_Z*Rad)  X2  Y2  Z2
                FSUBP   ST(1),ST;; X3  COS(_Z*Rad)  SIN(_Z*Rad)  X2  Y2  Z2
                FXCH    ST(3)   ;; X2  COS(_Z*Rad)  SIN(_Z*Rad)  X3  Y2  Z2
                FMULP   ST(2),ST;; COS(_Z*Rad)  X2*SIN(_Z*Rad)  X3  Y2  Z2
                FMULP   ST(3),ST;; X2*SIN(_Z*Rad)  X3  Y2*COS(_Z*Rad)  Z2
                FADDP   ST(2),ST;; X3  Y3  Z3

                FLD     PIVOT.Z ;; PZ  X3  Y3  Z3       ;Eltols
                FADDP   ST(3),ST;; X3  Y3  Z4
                FLD     PIVOT.Y ;; PY  X3  Y3  Z4
                FADDP   ST(2),ST;; X3  Y4  Z4
                FADD    PIVOT.X ;; X4  Y4  Z4

                FMUL    DIST    ;; DIST*X4  Y4  Z4      ;Perspektvikus vetts
                FLD     DIST    ;; DIST  DIST*X4  Y4  Z4
                FSUB    ST,ST(3);; DIST-Z4  DIST*X4  Y4  Z4
                FDIVP   ST(1),ST;; XX  Y4  Z4
                FISTP   XX      ;; Y4  Z4

                FMUL    DIST    ;; DIST*Y4  Z4
                FLD     DIST    ;; DIST  DIST*Y4  Z4
                FSUB    ST,ST(2);; DIST-Z4  DIST*Y4  Z4
                FDIVP   ST(1),ST;; YY  Z4
                FISTP   YY      ;; ZZ   

                FISTP   ZZ      ;; -

                ADD     XX,Sorhossz/2           ; Kzpre igazts
                ADD     YY,Sorok/2

                CMP     YY,Sorok                ; Vgs
                JNB     @@6
                CMP     XX,Sorhossz
                JNB     @@6

                IMUL    DI,YY,Sorhossz          ; Kirajzols a kpernyre
                ADD     DI,XX
                MOV     AL,15
                STOSB
@@6:
                ADD     SI,SIZE Vector          ; Lps a kvetkez pontra
                DEC     ECX
                JNZ     @@5

                ADD     ALFA,8                  ; j ALFA
                ADD     BETA,12                 ; j BETA
                ADD     GAMMA,20                ; j GAMMA
                AND     ALFA,4*SINLEN-4
                AND     BETA,4*SINLEN-4
                AND     GAMMA,4*SINLEN-4

                MOV     AH,1                    ; Ha nem trtnt billenty
                INT     16H                     ; nyoms, akkor jabb fzis
                JZ      @@2                     ; kirajzolsa kvetkezik.

                MOV     AH,0                    ; Kilps a programbl
                INT     16H
                MOV     AX,3
                INT     10H
                EXITCODE 0

Vector          STRUC           ;;Trbeli vektor struktrja
X               DD      ?       ;;X koordinta
Y               DD      ?       ;;Y koordinta
Z               DD      ?       ;;Z koordinta
Vector          ENDS

PIVOT           Vector<0.0,0.0,100.0>   ; Az objektum illesztsi pontja

DIST            DD      256.0           ; Kptvolsg

ALFA            DW      0               ; Forgatsi szg X tengely krl
BETA            DW      0               ; Forgatsi szg Y tengely krl
GAMMA           DW      0               ; Forgatsi szg Z tengely krl

XX              DW      ?               ; X koordinta transzformlt kpe
YY              DW      ?               ; Y koordinta transzformlt kpe
ZZ              DW      ?               ; Z koordinta transzformlt kpe

PONTOK LABEL DWORD                      ; Az objektum cme
INCLUDE CUBE.INC                        ; Vagy egy kocka
;INCLUDE BALL.INC                       ; Vagy egy labda

COUNT           DD      SINLEN/2
TRASH           DD      ?
SINTAB          DD      SINLEN+SINLEN/4 DUP(?)

Code16 ENDS
END START
