Comment /* Drtvzas trbeli objektum elforgatsa, eltolsa, majd
           lekpzse a skra (a kpernyre). */

SINLEN = 1024
Sorhossz = 320
Sorok = 200
.486
LOCALS
Code16 SEGMENT USE16
ASSUME CS:Code16, DS:Code16
                ORG 100H
START:
                MOV     AX,13H
                INT     10H
                MOV     AX,0A000H
                MOV     ES,AX
                MOV     CX,SINLEN+SINLEN/4
                MOV     SI,OFFSET SINTAB
                FNINIT
                FLDPI
                FIDIV   COUNT
                FLDZ
@@1:
                FLD     ST
                FSIN
                FSTP    DWORD PTR [SI]
                FADD    ST,ST(1)
                ADD     SI,4
                LOOP    @@1
                FSTP    TRASH
                FSTP    TRASH
@@2:
                MOV     SI,OFFSET PONTOK        ; Pontok transzformcija
                MOV     DI,OFFSET UJPONTOK      ; Transzformlt pontok cme
                MOV     ECX,[SI]
                ADD     SI,4
@@3:                                            ; Egy pont transzformcija
                FLD     [SI.X]  ;; X1
                MOV     BX,ALFA
                FLD     SINTAB[BX]
                FLD     SINTAB[BX+SINLEN]
                FLD     [SI.Y]  ;; Y0  COS(a)  SIN(a)  X1
                FMUL    ST,ST(1);; Y0*COS(a)  COS(a)  SIN(a)  X1
                FLD     [SI.Z]  ;; Z0  Y0*COS(a)  COS(a)  SIN(a)  X1
                FMUL    ST,ST(3);; Z0*SIN(a)  Y0*COS(a)  COS(a)  SIN(a)  X1
                FSUBP   ST(1),ST;; Y1  COS(a)  SIN(a)  X1
                FXCH    ST(2)   ;; SIN(a)  COS(a)  Y1  X1
                FMUL    [SI.Y]  ;; Y0*SIN(a)  COS(a)  Y1  X1
                FXCH    ST(1)   ;; COS(a)  Y0*SIN(a)  Y1  X1
                FMUL    [SI.Z]  ;; Z0*COS(a)  Y0*SIN(a)  Y1  X1
                FADDP   ST(1),ST;; Z1  Y1  X1
                MOV     BX,BETA
                FLD     SINTAB[BX]
                FLD     SINTAB[BX+SINLEN]
                FLD     ST(4)   ;; X1  COS(_Y*Rad)  SIN(_Y*Rad)  Z1  Y1  X1
                FMUL    ST,ST(1);; X1*COS(_Y*Rad)  COS(_Y*Rad)  SIN(_Y*Rad)  Z1  Y1  X1
                FLD     ST(3)   ;; Z1  X1*COS(_Y*Rad)  COS(_Y*Rad)  SIN(_Y*Rad)  Z1  Y1  X1
                FMUL    ST,ST(3);; Z1*SIN(_Y*Rad)  X1*COS(_Y*Rad)  COS(_Y*Rad)  SIN(_Y*Rad)  Z1  Y1  X1
                FADD            ;; X2  COS(_Y*Rad)  SIN(_Y*Rad)  Z1  Y2  X1
                FXCH    ST(2)   ;; SIN(_Y*Rad)  COS(_Y*Rad)  X2  Z1  Y2  X1
                FMULP   ST(5),ST;; COS(_Y*Rad)  X2  Z1  Y2  X1*SIN(_Y*Rad)
                FMULP   ST(2),ST;; X2  Z1*COS(_Y*Rad)  Y2  X1*SIN(_Y*Rad)
                FXCH            ;; Z1*COS(_Y*Rad)  X2  Y2  X1*SIN(_Y*Rad)
                FSUBRP  ST(3),ST;; X2  Y2  Z2
                MOV     BX,GAMMA
                FLD     SINTAB[BX]
                FLD     SINTAB[BX+SINLEN]
                FLD     ST(2)   ;; X2  COS(_Z*Rad)  SIN(_Z*Rad)  X2  Y2  Z2
                FMUL    ST,ST(1);; X2*COS(_Z*Rad)  COS(_Z*Rad)  SIN(_Z*Rad)  X2  Y2  Z2
                FLD     ST(4)   ;; Y2  X2*COS(_Z*Rad)  COS(_Z*Rad)  SIN(_Z*Rad)  X2  Y2  Z2
                FMUL    ST,ST(3);; Y2*SIN(_Z*Rad)  X2*COS(_Z*Rad)  COS(_Z*Rad)  SIN(_Z*Rad)  X2  Y2  Z2
                FSUBP   ST(1),ST;; X3  COS(_Z*Rad)  SIN(_Z*Rad)  X2  Y2  Z2
                FXCH    ST(3)   ;; X2  COS(_Z*Rad)  SIN(_Z*Rad)  X3  Y2  Z2
                FMULP   ST(2),ST;; COS(_Z*Rad)  X2*SIN(_Z*Rad)  X3  Y2  Z2
                FMULP   ST(3),ST;; X2*SIN(_Z*Rad)  X3  Y2*COS(_Z*Rad)  Z2
                FADDP   ST(2),ST;; X3  Y3  Z3

                FLD     PIVOT.Z ;; PZ  X3  Y3  Z3
                FADDP   ST(3),ST;; X3  Y3  Z4
                FLD     PIVOT.Y ;; PY  X3  Y3  Z4
                FADDP   ST(2),ST;; X3  Y4  Z4
                FADD    PIVOT.X ;; X4  Y4  Z4

                FMUL    DIST    ;; DIST*X4  Y4  Z4
                FLD     DIST    ;; DIST  DIST*X4  Y4  Z4
                FSUB    ST,ST(3);; DIST-Z4  DIST*X4  Y4  Z4
                FDIVP   ST(1),ST;; XX  Y4  Z4
                FISTP   [DI.X]  ;; Y4  Z4
                FMUL    DIST    ;; DIST*Y4  Z4
                FLD     DIST    ;; DIST  DIST*Y4  Z4
                FSUB    ST,ST(2);; DIST-Z4  DIST*Y4  Z4
                FDIVP   ST(1),ST;; YY  Z4
                FISTP   [DI.Y]  ;; ZZ   
                FISTP   [DI.Z]  ;; -

                ADD     [DI.X],Sorhossz/2
                ADD     [DI.Y],Sorok/2

                ADD     SI,SIZE Vector          ; Lps a kvetkez pontra
                ADD     DI,SIZE Vector
                DEC     ECX
                JNZ     @@3

                MOV     DX,3C8H
                MOV     AL,0
                OUT     DX,AL
                INC     DX
                OUT     DX,AL
                OUT     DX,AL
                OUT     DX,AL

                MOV     DX,3DAh                 ; Vrakozs a kperny
@@4:                                            ; kirajzolsra
                IN      AL,DX
                TEST    AL,8
                JZ      @@4
@@5:
                IN      AL,DX
                TEST    AL,1
                JZ      @@5

                MOV     DX,3C8H
                MOV     AL,0
                OUT     DX,AL
                INC     DX
                MOV     AL,63
                OUT     DX,AL
                MOV     AL,0
                OUT     DX,AL
                OUT     DX,AL

                SUB     DI,DI                   ; Kperny trlse
                MOV     CX,Sorhossz*Sorok/4
                SUB     EAX,EAX
                REP     STOSD

                MOV     DI,300+10*Sorhossz
                MOV     AL,14
                CALL    MONOGRAM

                MOV     DX,3C8H
                MOV     AL,0
                OUT     DX,AL
                INC     DX
                MOV     AL,63
                OUT     DX,AL
                OUT     DX,AL
                OUT     DX,AL
                                                ; lek kirajzolsa
                MOV     ECX,[SI]                ; lek szma
                ADD     SI,4
@@6:
                PUSH    CX SI

                MOV     AL,BYTE PTR [SI+8]
                MOV     SZIN,AL

                MOV     EBX,[SI]
                LEA     EBX,[EBX*2+EBX]         ; ADD     EBX,EBX
                LEA     EBX,UJPONTOK[EBX*4]     ; ADD     EBX,[SI]
                                                ; ADD     EBX,EBX
                                                ; ADD     EBX,EBX
                                                ; ADD     EBX,OFFSET UJPONTOK
                MOV     CX,WORD PTR [BX.X]
                MOV     BP,WORD PTR [BX.Y]

                MOV     EBX,[SI+4]
                LEA     EBX,[EBX*2+EBX]
                LEA     EBX,UJPONTOK[EBX*4]
                MOV     SI,WORD PTR [BX.X]
                MOV     DI,WORD PTR [BX.Y]

                CALL    LINE

                POP     SI CX                   ; Lps a kvetkez lre
                ADD     SI,4*3
                DEC     ECX
                JNZ     @@6

                MOV     DX,3C8H
                MOV     AL,0
                OUT     DX,AL
                INC     DX
                OUT     DX,AL
                MOV     AL,63
                OUT     DX,AL
                MOV     AL,0
                OUT     DX,AL

                ADD     ALFA,8
                ADD     BETA,12
                ADD     GAMMA,20
                AND     ALFA,4*SINLEN-4
                AND     BETA,4*SINLEN-4
                AND     GAMMA,4*SINLEN-4

                ADD     FAZIS,12
                AND     FAZIS,4*SINLEN-4
                MOV     BX,FAZIS
                FLD     SINTAB[BX]
                FMUL    SZORZO
                FSTP    PIVOT.X

                MOV     AH,1
                INT     16H
                JZ      @@2

                MOV     AH,0
                INT     16H

                CALL    SOTETIT

                MOV     AX,3
                INT     10H
                EXITCODE 0

;------------------------------------------------------------------------------
;DRAWING LINE 12-24-94 BY TOMCAT/ABADDON
;Based on Bresenham algorithm
;Publised by Paul S. Heckbert in Graphics Gems
;Translated to Assembly by Tamas Kaproncai tomcat@szif.hu

DrawLine        MACRO   _Plot,_Color
        LOCAL   _X2,_Y2,_1,_2,_3,_4,_5,_6,_7,_8

                MOV     _X2,SI
                MOV     _Y2,DI
                SUB     SI,CX           ;DX = X2 - X1
                SUB     DI,BP           ;DY = Y2 - Y1
                MOV     DX,SI
                MOV     BX,DI
                SHL     SI,1            ;AX = ABS(DX) * 2
                JNC     _1
                NEG     SI
_1:
                SHL     DI,1            ;AY = ABS(DY) * 2
                JNC     _2
                NEG     DI
_2:
                SAR     DX,16           ;SX = SGN(DX)
                SBB     DX,-1
                SAR     BX,16           ;SY = SGN(DY)
                SBB     BX,-1
                CMP     SI,DI
                JNA     _5              ;IF AX > AY
                MOV     AX,SI           ;  D = AY - AX / 2
                SHR     AX,1
                NEG     AX
                ADD     AX,DI
_3:                                     ;  DO
                _Plot CX,BP,_Color      ;    PLOT(X,Y)
                CMP     CX,_X2
                JE      _8              ;  UNTIL X = X2
                OR      AX,AX
                JS      _4              ;    IF D >= 0
                ADD     BP,BX           ;      Y += SY
                SUB     AX,SI           ;      D -= AX
_4:                                     ;    ENDIF
                ADD     CX,DX           ;    X += SX
                ADD     AX,DI           ;    D += AY
                JMP     _3              ;  ENDDO
        ALIGN 4
_X2             DW      ?
_Y2             DW      ?
_5:                                     ;ELSE
                MOV     AX,DI           ;  D = AX - AY / 2
                SHR     AX,1
                NEG     AX
                ADD     AX,SI
_6:                                     ;  DO
                _Plot CX,BP,_Color      ;    PLOT(X,Y)
                CMP     BP,_Y2
                JE      _8              ;  UNTIL Y = Y2
                OR      AX,AX
                JS      _7              ;    IF D >= 0
                ADD     CX,DX           ;      X += SX
                SUB     AX,DI           ;      D -= AY
_7:                                     ;    ENDIF
                ADD     BP,BX           ;    Y += SY
                ADD     AX,SI           ;    D += AX
                JMP     _6              ;  ENDDO
_8:                                     ;ENDIF
        ENDM
;------------------------------------------------------------------------------

PLOT            MACRO   _X,_Y,_C
        LOCAL   _1

                CMP     _Y,Sorok
                JNB     _1
                CMP     _X,Sorhossz
                JNB     _1
                PUSH    DI AX
                IMUL    DI,_Y,Sorhossz
                ADD     DI,_X
                MOV     AL,_C
                STOSB
                POP     AX DI
_1:
ENDM

LINE:           DrawLine PLOT,SZIN
                RETN
;------------------------------------------------------------------------------
MONOGRAM:
                MOV     ES:[DI],AL
                MOV     ES:[DI+Sorhossz],AL
                MOV     ES:[DI+Sorhossz*2],AL
                MOV     ES:[DI+Sorhossz*3],AL
                MOV     ES:[DI+Sorhossz*4],AL
                MOV     ES:[DI+3],AL
                MOV     ES:[DI+Sorhossz+2],AL
                MOV     ES:[DI+Sorhossz*2+1],AL
                MOV     ES:[DI+Sorhossz*3+2],AL
                MOV     ES:[DI+Sorhossz*4+3],AL
                MOV     ES:[DI+6],AL
                MOV     ES:[DI+Sorhossz+6],AL
                MOV     ES:[DI+Sorhossz*2+6],AL
                MOV     ES:[DI+Sorhossz*3+6],AL
                MOV     ES:[DI+Sorhossz*4+6],AL
                MOV     ES:[DI+5],AL
                MOV     ES:[DI+7],AL
                MOV     ES:[DI+8],AL
                RETN
;------------------------------------------------------------------------------
SOTETIT:
                MOV     SI,OFFSET PAL; Sznek eltrolsa
                MOV     DX,3C7H
                MOV     AL,0
                OUT     DX,AL
                ADD     DX,2
                MOV     CX,768
@@3:
                IN      AL,DX
                MOV     [SI],AL
                INC     SI
                LOOP    @@3

                MOV     BX,1            ; Levonand = 0, irny = +1
@@4:
                MOV     DI,63           ; 63 fzisonknt irny csere
@@4B:
                MOV     DX,3DAH
@@5:
                IN      AL,DX
                TEST    AL,8
                JNZ     @@5
@@6:
                IN      AL,DX
                TEST    AL,8
                JZ      @@6

                MOV     SI,OFFSET PAL; Aktulis paletta belltsa
                MOV     DX,3C8H
                MOV     AL,0
                OUT     DX,AL
                INC     DX
                MOV     CX,768
@@7:
                LODSB
                SUB     AL,BH           ; A konponens rtkbl levonunk
                JNS     @@8
                MOV     AL,0            ; Negatv rtk helyett 0
@@8:
                OUT     DX,AL
                LOOP    @@7             ; Kvetkez komponens
                ADD     BH,BL           ; Levonand lptetse
                DEC     DI
                JNZ     @@4B
                RETN
;------------------------------------------------------------------------------

Vector          STRUC
X               DD      ?
Y               DD      ?
Z               DD      ?
Vector          ENDS

SZIN            DB      0,0
FAZIS           DW      0
SZORZO          DD      3.0

PIVOT           Vector<0.0,0.0,248.0>   ; Az objektum koordinti kisebbek
                                        ; -> kzelebb megynk
DIST            DD      256.0

ALFA            DW      0
BETA            DW      0
GAMMA           DW      0

PONTOK LABEL DWORD
INCLUDE KOCKA.INC                       ; Kocka objektum pontokkal s lekkel

COUNT           DD      SINLEN/2
TRASH           DD      ?
SINTAB          DD      SINLEN+SINLEN/4 DUP(?)

PAL             DB      768 DUP(?)

UJPONTOK LABEL DWORD

Code16 ENDS
END START
